/* game-board.c generated by valac 0.56.14, the Vala compiler
 * generated from game-board.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Four-in-a-row.

   Copyright © 2018 Jacob Humphrey

   GNOME Four-in-a-row is free software: you can redistribute it and/or
   modify it under the terms of the GNU General Public License as published
   by the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Four-in-a-row is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with GNOME Four-in-a-row.  If not, see <https://www.gnu.org/licenses/>.
*/
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <glib-object.h>
#include <glib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_BOARD (board_get_type ())
#define BOARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOARD, Board))
#define BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOARD, BoardClass))
#define IS_BOARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOARD))
#define IS_BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOARD))
#define BOARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOARD, BoardClass))

typedef struct _Board Board;
typedef struct _BoardClass BoardClass;
typedef struct _BoardPrivate BoardPrivate;
enum  {
	BOARD_0_PROPERTY,
	BOARD_LINE_PROPERTY,
	BOARD_SIZE_PROPERTY,
	BOARD_NUM_PROPERTIES
};
static GParamSpec* board_properties[BOARD_NUM_PROPERTIES];
typedef enum  {
	PLAYER_NOBODY,
	PLAYER_HUMAN,
	PLAYER_OPPONENT
} Player;

#define TYPE_PLAYER (player_get_type ())

struct _Board {
	GObject parent_instance;
	BoardPrivate * priv;
};

struct _BoardClass {
	GObjectClass parent_class;
};

struct _BoardPrivate {
	guint8 _line;
	guint8 _size;
};

static gint Board_private_offset;
static gpointer board_parent_class = NULL;
static Player* board_gboard;
static gint board_gboard_length1;
static gint board_gboard_length2;
static Player* board_gboard = NULL;
static gint board_gboard_length1 = 0;
static gint board_gboard_length2 = 0;

VALA_EXTERN GType board_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Board, g_object_unref)
VALA_EXTERN GType player_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Board* board_new (guint8 size,
                  guint8 line);
VALA_EXTERN Board* board_construct (GType object_type,
                        guint8 size,
                        guint8 line);
VALA_EXTERN void board_set (Board* self,
                guint8 x,
                guint8 y,
                Player tile);
VALA_EXTERN Player board_get (Board* self,
                  guint8 x,
                  guint8 y);
VALA_EXTERN void board_clear (Board* self);
VALA_EXTERN guint8 board_get_size (Board* self);
VALA_EXTERN guint8 board_first_empty_row (Board* self,
                              guint8 col);
VALA_EXTERN gboolean board_is_line_at (Board* self,
                           Player tile,
                           guint8 row,
                           guint8 col,
                           guint8** lines,
                           gint* lines_length1,
                           gint* lines_length2);
static inline gboolean board_is_hline_at (Board* self,
                            Player tile,
                            guint8 row,
                            guint8 col,
                            guint8* row_1,
                            guint8* col_1,
                            guint8* row_2,
                            guint8* col_2);
static inline gboolean board_is_vline_at (Board* self,
                            Player tile,
                            guint8 row,
                            guint8 col,
                            guint8* row_1,
                            guint8* col_1,
                            guint8* row_2,
                            guint8* col_2);
static inline gboolean board_is_dline1_at (Board* self,
                             Player tile,
                             guint8 row,
                             guint8 col,
                             guint8* row_1,
                             guint8* col_1,
                             guint8* row_2,
                             guint8* col_2);
static inline gboolean board_is_dline2_at (Board* self,
                             Player tile,
                             guint8 row,
                             guint8 col,
                             guint8* row_1,
                             guint8* col_1,
                             guint8* row_2,
                             guint8* col_2);
VALA_EXTERN guint8 board_get_line (Board* self);
static void board_set_line (Board* self,
                     guint8 value);
static void board_set_size (Board* self,
                     guint8 value);
static GObject * board_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties);
static void board_finalize (GObject * obj);
static GType board_get_type_once (void);
static void _vala_board_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec);
static void _vala_board_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec);

static inline gpointer
board_get_instance_private (Board* self)
{
	return G_STRUCT_MEMBER_P (self, Board_private_offset);
}

Board*
board_construct (GType object_type,
                 guint8 size,
                 guint8 line)
{
	Board * self = NULL;
#line 35 "../src/game-board.vala"
	self = (Board*) g_object_new (object_type, "size", size, "line", line, NULL);
#line 33 "../src/game-board.vala"
	return self;
#line 185 "game-board.c"
}

Board*
board_new (guint8 size,
           guint8 line)
{
#line 33 "../src/game-board.vala"
	return board_construct (TYPE_BOARD, size, line);
#line 194 "game-board.c"
}

void
board_set (Board* self,
           guint8 x,
           guint8 y,
           Player tile)
{
	Player* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
#line 38 "../src/game-board.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/game-board.vala"
	_tmp0_ = board_gboard;
#line 40 "../src/game-board.vala"
	_tmp0__length1 = board_gboard_length1;
#line 40 "../src/game-board.vala"
	_tmp0__length2 = board_gboard_length2;
#line 40 "../src/game-board.vala"
	_tmp0_[(x * _tmp0__length2) + y] = tile;
#line 216 "game-board.c"
}

Player
board_get (Board* self,
           guint8 x,
           guint8 y)
{
	Player* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Player _tmp1_;
	Player result;
#line 43 "../src/game-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 45 "../src/game-board.vala"
	_tmp0_ = board_gboard;
#line 45 "../src/game-board.vala"
	_tmp0__length1 = board_gboard_length1;
#line 45 "../src/game-board.vala"
	_tmp0__length2 = board_gboard_length2;
#line 45 "../src/game-board.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 45 "../src/game-board.vala"
	result = _tmp1_;
#line 45 "../src/game-board.vala"
	return result;
#line 243 "game-board.c"
}

void
board_clear (Board* self)
{
#line 48 "../src/game-board.vala"
	g_return_if_fail (self != NULL);
#line 251 "game-board.c"
	{
		guint8 row = 0U;
#line 50 "../src/game-board.vala"
		row = (guint8) 0;
#line 256 "game-board.c"
		{
			gboolean _tmp0_ = FALSE;
#line 50 "../src/game-board.vala"
			_tmp0_ = TRUE;
#line 50 "../src/game-board.vala"
			while (TRUE) {
#line 263 "game-board.c"
				guint8 _tmp2_;
#line 50 "../src/game-board.vala"
				if (!_tmp0_) {
#line 267 "game-board.c"
					guint8 _tmp1_;
#line 50 "../src/game-board.vala"
					_tmp1_ = row;
#line 50 "../src/game-board.vala"
					row = _tmp1_ + 1;
#line 273 "game-board.c"
				}
#line 50 "../src/game-board.vala"
				_tmp0_ = FALSE;
#line 50 "../src/game-board.vala"
				_tmp2_ = self->priv->_size;
#line 50 "../src/game-board.vala"
				if (!(row < _tmp2_)) {
#line 50 "../src/game-board.vala"
					break;
#line 283 "game-board.c"
				}
				{
					guint8 col = 0U;
#line 51 "../src/game-board.vala"
					col = (guint8) 0;
#line 289 "game-board.c"
					{
						gboolean _tmp3_ = FALSE;
#line 51 "../src/game-board.vala"
						_tmp3_ = TRUE;
#line 51 "../src/game-board.vala"
						while (TRUE) {
#line 296 "game-board.c"
							guint8 _tmp5_;
							Player* _tmp6_;
							gint _tmp6__length1;
							gint _tmp6__length2;
#line 51 "../src/game-board.vala"
							if (!_tmp3_) {
#line 303 "game-board.c"
								guint8 _tmp4_;
#line 51 "../src/game-board.vala"
								_tmp4_ = col;
#line 51 "../src/game-board.vala"
								col = _tmp4_ + 1;
#line 309 "game-board.c"
							}
#line 51 "../src/game-board.vala"
							_tmp3_ = FALSE;
#line 51 "../src/game-board.vala"
							_tmp5_ = self->priv->_size;
#line 51 "../src/game-board.vala"
							if (!(col < _tmp5_)) {
#line 51 "../src/game-board.vala"
								break;
#line 319 "game-board.c"
							}
#line 52 "../src/game-board.vala"
							_tmp6_ = board_gboard;
#line 52 "../src/game-board.vala"
							_tmp6__length1 = board_gboard_length1;
#line 52 "../src/game-board.vala"
							_tmp6__length2 = board_gboard_length2;
#line 52 "../src/game-board.vala"
							_tmp6_[(row * _tmp6__length2) + col] = PLAYER_NOBODY;
#line 329 "game-board.c"
						}
					}
				}
			}
		}
	}
}

guint8
board_first_empty_row (Board* self,
                       guint8 col)
{
	guint8 row = 0U;
	guint8 result;
#line 55 "../src/game-board.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 57 "../src/game-board.vala"
	row = (guint8) 1;
#line 59 "../src/game-board.vala"
	while (TRUE) {
#line 350 "game-board.c"
		gboolean _tmp0_ = FALSE;
		guint8 _tmp1_;
		guint8 _tmp4_;
#line 59 "../src/game-board.vala"
		_tmp1_ = self->priv->_size;
#line 59 "../src/game-board.vala"
		if (row < _tmp1_) {
#line 358 "game-board.c"
			Player* _tmp2_;
			gint _tmp2__length1;
			gint _tmp2__length2;
			Player _tmp3_;
#line 59 "../src/game-board.vala"
			_tmp2_ = board_gboard;
#line 59 "../src/game-board.vala"
			_tmp2__length1 = board_gboard_length1;
#line 59 "../src/game-board.vala"
			_tmp2__length2 = board_gboard_length2;
#line 59 "../src/game-board.vala"
			_tmp3_ = _tmp2_[(row * _tmp2__length2) + col];
#line 59 "../src/game-board.vala"
			_tmp0_ = _tmp3_ == PLAYER_NOBODY;
#line 373 "game-board.c"
		} else {
#line 59 "../src/game-board.vala"
			_tmp0_ = FALSE;
#line 377 "game-board.c"
		}
#line 59 "../src/game-board.vala"
		if (!_tmp0_) {
#line 59 "../src/game-board.vala"
			break;
#line 383 "game-board.c"
		}
#line 60 "../src/game-board.vala"
		_tmp4_ = row;
#line 60 "../src/game-board.vala"
		row = _tmp4_ + 1;
#line 389 "game-board.c"
	}
#line 61 "../src/game-board.vala"
	result = (guint8) (row - 1);
#line 61 "../src/game-board.vala"
	return result;
#line 395 "game-board.c"
}

gboolean
board_is_line_at (Board* self,
                  Player tile,
                  guint8 row,
                  guint8 col,
                  guint8** lines,
                  gint* lines_length1,
                  gint* lines_length2)
{
	guint8* _vala_lines = NULL;
	gint _vala_lines_length1 = 0;
	gint _vala_lines_length2 = 0;
	guint8 n_lines = 0U;
	guint8* lines_tmp = NULL;
	guint8* _tmp0_;
	gint lines_tmp_length1;
	gint lines_tmp_length2;
	guint8* _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	guint8* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	guint8* _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	guint8* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	guint8 _tmp5_ = 0U;
	guint8 _tmp6_ = 0U;
	guint8 _tmp7_ = 0U;
	guint8 _tmp8_ = 0U;
	gboolean _tmp9_;
	guint8* _tmp11_;
	gint _tmp11__length1;
	gint _tmp11__length2;
	guint8* _tmp12_;
	gint _tmp12__length1;
	gint _tmp12__length2;
	guint8* _tmp13_;
	gint _tmp13__length1;
	gint _tmp13__length2;
	guint8* _tmp14_;
	gint _tmp14__length1;
	gint _tmp14__length2;
	guint8 _tmp15_ = 0U;
	guint8 _tmp16_ = 0U;
	guint8 _tmp17_ = 0U;
	guint8 _tmp18_ = 0U;
	gboolean _tmp19_;
	guint8* _tmp21_;
	gint _tmp21__length1;
	gint _tmp21__length2;
	guint8* _tmp22_;
	gint _tmp22__length1;
	gint _tmp22__length2;
	guint8* _tmp23_;
	gint _tmp23__length1;
	gint _tmp23__length2;
	guint8* _tmp24_;
	gint _tmp24__length1;
	gint _tmp24__length2;
	guint8 _tmp25_ = 0U;
	guint8 _tmp26_ = 0U;
	guint8 _tmp27_ = 0U;
	guint8 _tmp28_ = 0U;
	gboolean _tmp29_;
	guint8* _tmp31_;
	gint _tmp31__length1;
	gint _tmp31__length2;
	guint8* _tmp32_;
	gint _tmp32__length1;
	gint _tmp32__length2;
	guint8* _tmp33_;
	gint _tmp33__length1;
	gint _tmp33__length2;
	guint8* _tmp34_;
	gint _tmp34__length1;
	gint _tmp34__length2;
	guint8 _tmp35_ = 0U;
	guint8 _tmp36_ = 0U;
	guint8 _tmp37_ = 0U;
	guint8 _tmp38_ = 0U;
	gboolean _tmp39_;
	guint8* _tmp41_;
	gboolean result;
#line 68 "../src/game-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 70 "../src/game-board.vala"
	n_lines = (guint8) 0;
#line 71 "../src/game-board.vala"
	_tmp0_ = g_new0 (guint8, 4 * 4);
#line 71 "../src/game-board.vala"
	lines_tmp = _tmp0_;
#line 71 "../src/game-board.vala"
	lines_tmp_length1 = 4;
#line 71 "../src/game-board.vala"
	lines_tmp_length2 = 4;
#line 73 "../src/game-board.vala"
	_tmp1_ = lines_tmp;
#line 73 "../src/game-board.vala"
	_tmp1__length1 = lines_tmp_length1;
#line 73 "../src/game-board.vala"
	_tmp1__length2 = lines_tmp_length2;
#line 73 "../src/game-board.vala"
	_tmp2_ = lines_tmp;
#line 73 "../src/game-board.vala"
	_tmp2__length1 = lines_tmp_length1;
#line 73 "../src/game-board.vala"
	_tmp2__length2 = lines_tmp_length2;
#line 73 "../src/game-board.vala"
	_tmp3_ = lines_tmp;
#line 73 "../src/game-board.vala"
	_tmp3__length1 = lines_tmp_length1;
#line 73 "../src/game-board.vala"
	_tmp3__length2 = lines_tmp_length2;
#line 73 "../src/game-board.vala"
	_tmp4_ = lines_tmp;
#line 73 "../src/game-board.vala"
	_tmp4__length1 = lines_tmp_length1;
#line 73 "../src/game-board.vala"
	_tmp4__length2 = lines_tmp_length2;
#line 73 "../src/game-board.vala"
	_tmp9_ = board_is_hline_at (self, tile, row, col, &_tmp5_, &_tmp6_, &_tmp7_, &_tmp8_);
#line 73 "../src/game-board.vala"
	_tmp1_[(0 * _tmp1__length2) + 0] = _tmp5_;
#line 73 "../src/game-board.vala"
	_tmp2_[(0 * _tmp2__length2) + 1] = _tmp6_;
#line 73 "../src/game-board.vala"
	_tmp3_[(0 * _tmp3__length2) + 2] = _tmp7_;
#line 73 "../src/game-board.vala"
	_tmp4_[(0 * _tmp4__length2) + 3] = _tmp8_;
#line 73 "../src/game-board.vala"
	if (_tmp9_) {
#line 533 "game-board.c"
		guint8 _tmp10_;
#line 77 "../src/game-board.vala"
		_tmp10_ = n_lines;
#line 77 "../src/game-board.vala"
		n_lines = _tmp10_ + 1;
#line 539 "game-board.c"
	}
#line 78 "../src/game-board.vala"
	_tmp11_ = lines_tmp;
#line 78 "../src/game-board.vala"
	_tmp11__length1 = lines_tmp_length1;
#line 78 "../src/game-board.vala"
	_tmp11__length2 = lines_tmp_length2;
#line 78 "../src/game-board.vala"
	_tmp12_ = lines_tmp;
#line 78 "../src/game-board.vala"
	_tmp12__length1 = lines_tmp_length1;
#line 78 "../src/game-board.vala"
	_tmp12__length2 = lines_tmp_length2;
#line 78 "../src/game-board.vala"
	_tmp13_ = lines_tmp;
#line 78 "../src/game-board.vala"
	_tmp13__length1 = lines_tmp_length1;
#line 78 "../src/game-board.vala"
	_tmp13__length2 = lines_tmp_length2;
#line 78 "../src/game-board.vala"
	_tmp14_ = lines_tmp;
#line 78 "../src/game-board.vala"
	_tmp14__length1 = lines_tmp_length1;
#line 78 "../src/game-board.vala"
	_tmp14__length2 = lines_tmp_length2;
#line 78 "../src/game-board.vala"
	_tmp19_ = board_is_vline_at (self, tile, row, col, &_tmp15_, &_tmp16_, &_tmp17_, &_tmp18_);
#line 78 "../src/game-board.vala"
	_tmp11_[(n_lines * _tmp11__length2) + 0] = _tmp15_;
#line 78 "../src/game-board.vala"
	_tmp12_[(n_lines * _tmp12__length2) + 1] = _tmp16_;
#line 78 "../src/game-board.vala"
	_tmp13_[(n_lines * _tmp13__length2) + 2] = _tmp17_;
#line 78 "../src/game-board.vala"
	_tmp14_[(n_lines * _tmp14__length2) + 3] = _tmp18_;
#line 78 "../src/game-board.vala"
	if (_tmp19_) {
#line 577 "game-board.c"
		guint8 _tmp20_;
#line 82 "../src/game-board.vala"
		_tmp20_ = n_lines;
#line 82 "../src/game-board.vala"
		n_lines = _tmp20_ + 1;
#line 583 "game-board.c"
	}
#line 83 "../src/game-board.vala"
	_tmp21_ = lines_tmp;
#line 83 "../src/game-board.vala"
	_tmp21__length1 = lines_tmp_length1;
#line 83 "../src/game-board.vala"
	_tmp21__length2 = lines_tmp_length2;
#line 83 "../src/game-board.vala"
	_tmp22_ = lines_tmp;
#line 83 "../src/game-board.vala"
	_tmp22__length1 = lines_tmp_length1;
#line 83 "../src/game-board.vala"
	_tmp22__length2 = lines_tmp_length2;
#line 83 "../src/game-board.vala"
	_tmp23_ = lines_tmp;
#line 83 "../src/game-board.vala"
	_tmp23__length1 = lines_tmp_length1;
#line 83 "../src/game-board.vala"
	_tmp23__length2 = lines_tmp_length2;
#line 83 "../src/game-board.vala"
	_tmp24_ = lines_tmp;
#line 83 "../src/game-board.vala"
	_tmp24__length1 = lines_tmp_length1;
#line 83 "../src/game-board.vala"
	_tmp24__length2 = lines_tmp_length2;
#line 83 "../src/game-board.vala"
	_tmp29_ = board_is_dline1_at (self, tile, row, col, &_tmp25_, &_tmp26_, &_tmp27_, &_tmp28_);
#line 83 "../src/game-board.vala"
	_tmp21_[(n_lines * _tmp21__length2) + 0] = _tmp25_;
#line 83 "../src/game-board.vala"
	_tmp22_[(n_lines * _tmp22__length2) + 1] = _tmp26_;
#line 83 "../src/game-board.vala"
	_tmp23_[(n_lines * _tmp23__length2) + 2] = _tmp27_;
#line 83 "../src/game-board.vala"
	_tmp24_[(n_lines * _tmp24__length2) + 3] = _tmp28_;
#line 83 "../src/game-board.vala"
	if (_tmp29_) {
#line 621 "game-board.c"
		guint8 _tmp30_;
#line 87 "../src/game-board.vala"
		_tmp30_ = n_lines;
#line 87 "../src/game-board.vala"
		n_lines = _tmp30_ + 1;
#line 627 "game-board.c"
	}
#line 88 "../src/game-board.vala"
	_tmp31_ = lines_tmp;
#line 88 "../src/game-board.vala"
	_tmp31__length1 = lines_tmp_length1;
#line 88 "../src/game-board.vala"
	_tmp31__length2 = lines_tmp_length2;
#line 88 "../src/game-board.vala"
	_tmp32_ = lines_tmp;
#line 88 "../src/game-board.vala"
	_tmp32__length1 = lines_tmp_length1;
#line 88 "../src/game-board.vala"
	_tmp32__length2 = lines_tmp_length2;
#line 88 "../src/game-board.vala"
	_tmp33_ = lines_tmp;
#line 88 "../src/game-board.vala"
	_tmp33__length1 = lines_tmp_length1;
#line 88 "../src/game-board.vala"
	_tmp33__length2 = lines_tmp_length2;
#line 88 "../src/game-board.vala"
	_tmp34_ = lines_tmp;
#line 88 "../src/game-board.vala"
	_tmp34__length1 = lines_tmp_length1;
#line 88 "../src/game-board.vala"
	_tmp34__length2 = lines_tmp_length2;
#line 88 "../src/game-board.vala"
	_tmp39_ = board_is_dline2_at (self, tile, row, col, &_tmp35_, &_tmp36_, &_tmp37_, &_tmp38_);
#line 88 "../src/game-board.vala"
	_tmp31_[(n_lines * _tmp31__length2) + 0] = _tmp35_;
#line 88 "../src/game-board.vala"
	_tmp32_[(n_lines * _tmp32__length2) + 1] = _tmp36_;
#line 88 "../src/game-board.vala"
	_tmp33_[(n_lines * _tmp33__length2) + 2] = _tmp37_;
#line 88 "../src/game-board.vala"
	_tmp34_[(n_lines * _tmp34__length2) + 3] = _tmp38_;
#line 88 "../src/game-board.vala"
	if (_tmp39_) {
#line 665 "game-board.c"
		guint8 _tmp40_;
#line 92 "../src/game-board.vala"
		_tmp40_ = n_lines;
#line 92 "../src/game-board.vala"
		n_lines = _tmp40_ + 1;
#line 671 "game-board.c"
	}
#line 94 "../src/game-board.vala"
	_tmp41_ = g_new0 (guint8, n_lines * 4);
#line 94 "../src/game-board.vala"
	_vala_lines = (g_free (_vala_lines), NULL);
#line 94 "../src/game-board.vala"
	_vala_lines = _tmp41_;
#line 94 "../src/game-board.vala"
	_vala_lines_length1 = n_lines;
#line 94 "../src/game-board.vala"
	_vala_lines_length2 = 4;
#line 683 "game-board.c"
	{
		guint8 x = 0U;
#line 95 "../src/game-board.vala"
		x = (guint8) 0;
#line 688 "game-board.c"
		{
			gboolean _tmp42_ = FALSE;
#line 95 "../src/game-board.vala"
			_tmp42_ = TRUE;
#line 95 "../src/game-board.vala"
			while (TRUE) {
#line 95 "../src/game-board.vala"
				if (!_tmp42_) {
#line 697 "game-board.c"
					guint8 _tmp43_;
#line 95 "../src/game-board.vala"
					_tmp43_ = x;
#line 95 "../src/game-board.vala"
					x = _tmp43_ + 1;
#line 703 "game-board.c"
				}
#line 95 "../src/game-board.vala"
				_tmp42_ = FALSE;
#line 95 "../src/game-board.vala"
				if (!(x < n_lines)) {
#line 95 "../src/game-board.vala"
					break;
#line 711 "game-board.c"
				}
				{
					guint8 y = 0U;
#line 96 "../src/game-board.vala"
					y = (guint8) 0;
#line 717 "game-board.c"
					{
						gboolean _tmp44_ = FALSE;
#line 96 "../src/game-board.vala"
						_tmp44_ = TRUE;
#line 96 "../src/game-board.vala"
						while (TRUE) {
#line 724 "game-board.c"
							guint8* _tmp46_;
							gint _tmp46__length1;
							gint _tmp46__length2;
							guint8* _tmp47_;
							gint _tmp47__length1;
							gint _tmp47__length2;
							guint8 _tmp48_;
#line 96 "../src/game-board.vala"
							if (!_tmp44_) {
#line 734 "game-board.c"
								guint8 _tmp45_;
#line 96 "../src/game-board.vala"
								_tmp45_ = y;
#line 96 "../src/game-board.vala"
								y = _tmp45_ + 1;
#line 740 "game-board.c"
							}
#line 96 "../src/game-board.vala"
							_tmp44_ = FALSE;
#line 96 "../src/game-board.vala"
							if (!(((gint) y) < 4)) {
#line 96 "../src/game-board.vala"
								break;
#line 748 "game-board.c"
							}
#line 97 "../src/game-board.vala"
							_tmp46_ = _vala_lines;
#line 97 "../src/game-board.vala"
							_tmp46__length1 = _vala_lines_length1;
#line 97 "../src/game-board.vala"
							_tmp46__length2 = _vala_lines_length2;
#line 97 "../src/game-board.vala"
							_tmp47_ = lines_tmp;
#line 97 "../src/game-board.vala"
							_tmp47__length1 = lines_tmp_length1;
#line 97 "../src/game-board.vala"
							_tmp47__length2 = lines_tmp_length2;
#line 97 "../src/game-board.vala"
							_tmp48_ = _tmp47_[(x * _tmp47__length2) + y];
#line 97 "../src/game-board.vala"
							_tmp46_[(x * _tmp46__length2) + y] = _tmp48_;
#line 766 "game-board.c"
						}
					}
				}
			}
		}
	}
#line 98 "../src/game-board.vala"
	result = ((gint) n_lines) != 0;
#line 98 "../src/game-board.vala"
	lines_tmp = (g_free (lines_tmp), NULL);
#line 98 "../src/game-board.vala"
	if (lines) {
#line 98 "../src/game-board.vala"
		*lines = _vala_lines;
#line 781 "game-board.c"
	} else {
#line 98 "../src/game-board.vala"
		_vala_lines = (g_free (_vala_lines), NULL);
#line 785 "game-board.c"
	}
#line 98 "../src/game-board.vala"
	if (lines_length1) {
#line 98 "../src/game-board.vala"
		*lines_length1 = _vala_lines_length1;
#line 791 "game-board.c"
	}
#line 98 "../src/game-board.vala"
	if (lines_length2) {
#line 98 "../src/game-board.vala"
		*lines_length2 = _vala_lines_length2;
#line 797 "game-board.c"
	}
#line 98 "../src/game-board.vala"
	return result;
#line 801 "game-board.c"
}

static inline gboolean
board_is_hline_at (Board* self,
                   Player tile,
                   guint8 row,
                   guint8 col,
                   guint8* row_1,
                   guint8* col_1,
                   guint8* row_2,
                   guint8* col_2)
{
	guint8 _vala_row_1 = 0U;
	guint8 _vala_col_1 = 0U;
	guint8 _vala_row_2 = 0U;
	guint8 _vala_col_2 = 0U;
	guint8 _tmp7_;
	gboolean result;
#line 101 "../src/game-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 105 "../src/game-board.vala"
	_vala_row_1 = row;
#line 106 "../src/game-board.vala"
	_vala_row_2 = row;
#line 107 "../src/game-board.vala"
	_vala_col_1 = col;
#line 108 "../src/game-board.vala"
	_vala_col_2 = col;
#line 109 "../src/game-board.vala"
	while (TRUE) {
#line 832 "game-board.c"
		gboolean _tmp0_ = FALSE;
#line 109 "../src/game-board.vala"
		if (((gint) _vala_col_1) > 0) {
#line 836 "game-board.c"
			Player* _tmp1_;
			gint _tmp1__length1;
			gint _tmp1__length2;
			Player _tmp2_;
#line 109 "../src/game-board.vala"
			_tmp1_ = board_gboard;
#line 109 "../src/game-board.vala"
			_tmp1__length1 = board_gboard_length1;
#line 109 "../src/game-board.vala"
			_tmp1__length2 = board_gboard_length2;
#line 109 "../src/game-board.vala"
			_tmp2_ = _tmp1_[(row * _tmp1__length2) + (_vala_col_1 - 1)];
#line 109 "../src/game-board.vala"
			_tmp0_ = _tmp2_ == tile;
#line 851 "game-board.c"
		} else {
#line 109 "../src/game-board.vala"
			_tmp0_ = FALSE;
#line 855 "game-board.c"
		}
#line 109 "../src/game-board.vala"
		if (!_tmp0_) {
#line 109 "../src/game-board.vala"
			break;
#line 861 "game-board.c"
		}
#line 110 "../src/game-board.vala"
		_vala_col_1 = (guint8) (_vala_col_1 - 1);
#line 865 "game-board.c"
	}
#line 111 "../src/game-board.vala"
	while (TRUE) {
#line 869 "game-board.c"
		gboolean _tmp3_ = FALSE;
		guint8 _tmp4_;
#line 111 "../src/game-board.vala"
		_tmp4_ = self->priv->_size;
#line 111 "../src/game-board.vala"
		if (((gint) _vala_col_2) < (_tmp4_ - 1)) {
#line 876 "game-board.c"
			Player* _tmp5_;
			gint _tmp5__length1;
			gint _tmp5__length2;
			Player _tmp6_;
#line 111 "../src/game-board.vala"
			_tmp5_ = board_gboard;
#line 111 "../src/game-board.vala"
			_tmp5__length1 = board_gboard_length1;
#line 111 "../src/game-board.vala"
			_tmp5__length2 = board_gboard_length2;
#line 111 "../src/game-board.vala"
			_tmp6_ = _tmp5_[(row * _tmp5__length2) + (_vala_col_2 + 1)];
#line 111 "../src/game-board.vala"
			_tmp3_ = _tmp6_ == tile;
#line 891 "game-board.c"
		} else {
#line 111 "../src/game-board.vala"
			_tmp3_ = FALSE;
#line 895 "game-board.c"
		}
#line 111 "../src/game-board.vala"
		if (!_tmp3_) {
#line 111 "../src/game-board.vala"
			break;
#line 901 "game-board.c"
		}
#line 112 "../src/game-board.vala"
		_vala_col_2 = (guint8) (_vala_col_2 + 1);
#line 905 "game-board.c"
	}
#line 113 "../src/game-board.vala"
	_tmp7_ = self->priv->_line;
#line 113 "../src/game-board.vala"
	result = ((gint) (_vala_col_2 - _vala_col_1)) >= (_tmp7_ - 1);
#line 113 "../src/game-board.vala"
	if (row_1) {
#line 113 "../src/game-board.vala"
		*row_1 = _vala_row_1;
#line 915 "game-board.c"
	}
#line 113 "../src/game-board.vala"
	if (col_1) {
#line 113 "../src/game-board.vala"
		*col_1 = _vala_col_1;
#line 921 "game-board.c"
	}
#line 113 "../src/game-board.vala"
	if (row_2) {
#line 113 "../src/game-board.vala"
		*row_2 = _vala_row_2;
#line 927 "game-board.c"
	}
#line 113 "../src/game-board.vala"
	if (col_2) {
#line 113 "../src/game-board.vala"
		*col_2 = _vala_col_2;
#line 933 "game-board.c"
	}
#line 113 "../src/game-board.vala"
	return result;
#line 937 "game-board.c"
}

static inline gboolean
board_is_vline_at (Board* self,
                   Player tile,
                   guint8 row,
                   guint8 col,
                   guint8* row_1,
                   guint8* col_1,
                   guint8* row_2,
                   guint8* col_2)
{
	guint8 _vala_row_1 = 0U;
	guint8 _vala_col_1 = 0U;
	guint8 _vala_row_2 = 0U;
	guint8 _vala_col_2 = 0U;
	guint8 _tmp7_;
	gboolean result;
#line 116 "../src/game-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 120 "../src/game-board.vala"
	_vala_row_1 = row;
#line 121 "../src/game-board.vala"
	_vala_row_2 = row;
#line 122 "../src/game-board.vala"
	_vala_col_1 = col;
#line 123 "../src/game-board.vala"
	_vala_col_2 = col;
#line 124 "../src/game-board.vala"
	while (TRUE) {
#line 968 "game-board.c"
		gboolean _tmp0_ = FALSE;
#line 124 "../src/game-board.vala"
		if (((gint) _vala_row_1) > 1) {
#line 972 "game-board.c"
			Player* _tmp1_;
			gint _tmp1__length1;
			gint _tmp1__length2;
			Player _tmp2_;
#line 124 "../src/game-board.vala"
			_tmp1_ = board_gboard;
#line 124 "../src/game-board.vala"
			_tmp1__length1 = board_gboard_length1;
#line 124 "../src/game-board.vala"
			_tmp1__length2 = board_gboard_length2;
#line 124 "../src/game-board.vala"
			_tmp2_ = _tmp1_[((_vala_row_1 - 1) * _tmp1__length2) + col];
#line 124 "../src/game-board.vala"
			_tmp0_ = _tmp2_ == tile;
#line 987 "game-board.c"
		} else {
#line 124 "../src/game-board.vala"
			_tmp0_ = FALSE;
#line 991 "game-board.c"
		}
#line 124 "../src/game-board.vala"
		if (!_tmp0_) {
#line 124 "../src/game-board.vala"
			break;
#line 997 "game-board.c"
		}
#line 125 "../src/game-board.vala"
		_vala_row_1 = (guint8) (_vala_row_1 - 1);
#line 1001 "game-board.c"
	}
#line 126 "../src/game-board.vala"
	while (TRUE) {
#line 1005 "game-board.c"
		gboolean _tmp3_ = FALSE;
		guint8 _tmp4_;
#line 126 "../src/game-board.vala"
		_tmp4_ = self->priv->_size;
#line 126 "../src/game-board.vala"
		if (((gint) _vala_row_2) < (_tmp4_ - 1)) {
#line 1012 "game-board.c"
			Player* _tmp5_;
			gint _tmp5__length1;
			gint _tmp5__length2;
			Player _tmp6_;
#line 126 "../src/game-board.vala"
			_tmp5_ = board_gboard;
#line 126 "../src/game-board.vala"
			_tmp5__length1 = board_gboard_length1;
#line 126 "../src/game-board.vala"
			_tmp5__length2 = board_gboard_length2;
#line 126 "../src/game-board.vala"
			_tmp6_ = _tmp5_[((_vala_row_2 + 1) * _tmp5__length2) + col];
#line 126 "../src/game-board.vala"
			_tmp3_ = _tmp6_ == tile;
#line 1027 "game-board.c"
		} else {
#line 126 "../src/game-board.vala"
			_tmp3_ = FALSE;
#line 1031 "game-board.c"
		}
#line 126 "../src/game-board.vala"
		if (!_tmp3_) {
#line 126 "../src/game-board.vala"
			break;
#line 1037 "game-board.c"
		}
#line 127 "../src/game-board.vala"
		_vala_row_2 = (guint8) (_vala_row_2 + 1);
#line 1041 "game-board.c"
	}
#line 128 "../src/game-board.vala"
	_tmp7_ = self->priv->_line;
#line 128 "../src/game-board.vala"
	result = ((gint) (_vala_row_2 - _vala_row_1)) >= (_tmp7_ - 1);
#line 128 "../src/game-board.vala"
	if (row_1) {
#line 128 "../src/game-board.vala"
		*row_1 = _vala_row_1;
#line 1051 "game-board.c"
	}
#line 128 "../src/game-board.vala"
	if (col_1) {
#line 128 "../src/game-board.vala"
		*col_1 = _vala_col_1;
#line 1057 "game-board.c"
	}
#line 128 "../src/game-board.vala"
	if (row_2) {
#line 128 "../src/game-board.vala"
		*row_2 = _vala_row_2;
#line 1063 "game-board.c"
	}
#line 128 "../src/game-board.vala"
	if (col_2) {
#line 128 "../src/game-board.vala"
		*col_2 = _vala_col_2;
#line 1069 "game-board.c"
	}
#line 128 "../src/game-board.vala"
	return result;
#line 1073 "game-board.c"
}

static inline gboolean
board_is_dline1_at (Board* self,
                    Player tile,
                    guint8 row,
                    guint8 col,
                    guint8* row_1,
                    guint8* col_1,
                    guint8* row_2,
                    guint8* col_2)
{
	guint8 _vala_row_1 = 0U;
	guint8 _vala_col_1 = 0U;
	guint8 _vala_row_2 = 0U;
	guint8 _vala_col_2 = 0U;
	guint8 _tmp10_;
	gboolean result;
#line 131 "../src/game-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 136 "../src/game-board.vala"
	_vala_row_1 = row;
#line 137 "../src/game-board.vala"
	_vala_row_2 = row;
#line 138 "../src/game-board.vala"
	_vala_col_1 = col;
#line 139 "../src/game-board.vala"
	_vala_col_2 = col;
#line 140 "../src/game-board.vala"
	while (TRUE) {
#line 1104 "game-board.c"
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_ = FALSE;
#line 140 "../src/game-board.vala"
		if (((gint) _vala_col_1) > 0) {
#line 140 "../src/game-board.vala"
			_tmp1_ = ((gint) _vala_row_1) > 1;
#line 1111 "game-board.c"
		} else {
#line 140 "../src/game-board.vala"
			_tmp1_ = FALSE;
#line 1115 "game-board.c"
		}
#line 140 "../src/game-board.vala"
		if (_tmp1_) {
#line 1119 "game-board.c"
			Player* _tmp2_;
			gint _tmp2__length1;
			gint _tmp2__length2;
			Player _tmp3_;
#line 140 "../src/game-board.vala"
			_tmp2_ = board_gboard;
#line 140 "../src/game-board.vala"
			_tmp2__length1 = board_gboard_length1;
#line 140 "../src/game-board.vala"
			_tmp2__length2 = board_gboard_length2;
#line 140 "../src/game-board.vala"
			_tmp3_ = _tmp2_[((_vala_row_1 - 1) * _tmp2__length2) + (_vala_col_1 - 1)];
#line 140 "../src/game-board.vala"
			_tmp0_ = _tmp3_ == tile;
#line 1134 "game-board.c"
		} else {
#line 140 "../src/game-board.vala"
			_tmp0_ = FALSE;
#line 1138 "game-board.c"
		}
#line 140 "../src/game-board.vala"
		if (!_tmp0_) {
#line 140 "../src/game-board.vala"
			break;
#line 1144 "game-board.c"
		}
#line 142 "../src/game-board.vala"
		_vala_row_1 = (guint8) (_vala_row_1 - 1);
#line 143 "../src/game-board.vala"
		_vala_col_1 = (guint8) (_vala_col_1 - 1);
#line 1150 "game-board.c"
	}
#line 145 "../src/game-board.vala"
	while (TRUE) {
#line 1154 "game-board.c"
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		guint8 _tmp6_;
#line 145 "../src/game-board.vala"
		_tmp6_ = self->priv->_size;
#line 145 "../src/game-board.vala"
		if (((gint) _vala_col_2) < (_tmp6_ - 1)) {
#line 1162 "game-board.c"
			guint8 _tmp7_;
#line 145 "../src/game-board.vala"
			_tmp7_ = self->priv->_size;
#line 145 "../src/game-board.vala"
			_tmp5_ = ((gint) _vala_row_2) < (_tmp7_ - 1);
#line 1168 "game-board.c"
		} else {
#line 145 "../src/game-board.vala"
			_tmp5_ = FALSE;
#line 1172 "game-board.c"
		}
#line 145 "../src/game-board.vala"
		if (_tmp5_) {
#line 1176 "game-board.c"
			Player* _tmp8_;
			gint _tmp8__length1;
			gint _tmp8__length2;
			Player _tmp9_;
#line 145 "../src/game-board.vala"
			_tmp8_ = board_gboard;
#line 145 "../src/game-board.vala"
			_tmp8__length1 = board_gboard_length1;
#line 145 "../src/game-board.vala"
			_tmp8__length2 = board_gboard_length2;
#line 145 "../src/game-board.vala"
			_tmp9_ = _tmp8_[((_vala_row_2 + 1) * _tmp8__length2) + (_vala_col_2 + 1)];
#line 145 "../src/game-board.vala"
			_tmp4_ = _tmp9_ == tile;
#line 1191 "game-board.c"
		} else {
#line 145 "../src/game-board.vala"
			_tmp4_ = FALSE;
#line 1195 "game-board.c"
		}
#line 145 "../src/game-board.vala"
		if (!_tmp4_) {
#line 145 "../src/game-board.vala"
			break;
#line 1201 "game-board.c"
		}
#line 147 "../src/game-board.vala"
		_vala_row_2 = (guint8) (_vala_row_2 + 1);
#line 148 "../src/game-board.vala"
		_vala_col_2 = (guint8) (_vala_col_2 + 1);
#line 1207 "game-board.c"
	}
#line 150 "../src/game-board.vala"
	_tmp10_ = self->priv->_line;
#line 150 "../src/game-board.vala"
	result = ((gint) (_vala_row_2 - _vala_row_1)) >= (_tmp10_ - 1);
#line 150 "../src/game-board.vala"
	if (row_1) {
#line 150 "../src/game-board.vala"
		*row_1 = _vala_row_1;
#line 1217 "game-board.c"
	}
#line 150 "../src/game-board.vala"
	if (col_1) {
#line 150 "../src/game-board.vala"
		*col_1 = _vala_col_1;
#line 1223 "game-board.c"
	}
#line 150 "../src/game-board.vala"
	if (row_2) {
#line 150 "../src/game-board.vala"
		*row_2 = _vala_row_2;
#line 1229 "game-board.c"
	}
#line 150 "../src/game-board.vala"
	if (col_2) {
#line 150 "../src/game-board.vala"
		*col_2 = _vala_col_2;
#line 1235 "game-board.c"
	}
#line 150 "../src/game-board.vala"
	return result;
#line 1239 "game-board.c"
}

static inline gboolean
board_is_dline2_at (Board* self,
                    Player tile,
                    guint8 row,
                    guint8 col,
                    guint8* row_1,
                    guint8* col_1,
                    guint8* row_2,
                    guint8* col_2)
{
	guint8 _vala_row_1 = 0U;
	guint8 _vala_col_1 = 0U;
	guint8 _vala_row_2 = 0U;
	guint8 _vala_col_2 = 0U;
	guint8 _tmp10_;
	gboolean result;
#line 153 "../src/game-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 158 "../src/game-board.vala"
	_vala_row_1 = row;
#line 159 "../src/game-board.vala"
	_vala_row_2 = row;
#line 160 "../src/game-board.vala"
	_vala_col_1 = col;
#line 161 "../src/game-board.vala"
	_vala_col_2 = col;
#line 162 "../src/game-board.vala"
	while (TRUE) {
#line 1270 "game-board.c"
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_ = FALSE;
		guint8 _tmp2_;
#line 162 "../src/game-board.vala"
		_tmp2_ = self->priv->_size;
#line 162 "../src/game-board.vala"
		if (((gint) _vala_col_1) < (_tmp2_ - 1)) {
#line 162 "../src/game-board.vala"
			_tmp1_ = ((gint) _vala_row_1) > 1;
#line 1280 "game-board.c"
		} else {
#line 162 "../src/game-board.vala"
			_tmp1_ = FALSE;
#line 1284 "game-board.c"
		}
#line 162 "../src/game-board.vala"
		if (_tmp1_) {
#line 1288 "game-board.c"
			Player* _tmp3_;
			gint _tmp3__length1;
			gint _tmp3__length2;
			Player _tmp4_;
#line 162 "../src/game-board.vala"
			_tmp3_ = board_gboard;
#line 162 "../src/game-board.vala"
			_tmp3__length1 = board_gboard_length1;
#line 162 "../src/game-board.vala"
			_tmp3__length2 = board_gboard_length2;
#line 162 "../src/game-board.vala"
			_tmp4_ = _tmp3_[((_vala_row_1 - 1) * _tmp3__length2) + (_vala_col_1 + 1)];
#line 162 "../src/game-board.vala"
			_tmp0_ = _tmp4_ == tile;
#line 1303 "game-board.c"
		} else {
#line 162 "../src/game-board.vala"
			_tmp0_ = FALSE;
#line 1307 "game-board.c"
		}
#line 162 "../src/game-board.vala"
		if (!_tmp0_) {
#line 162 "../src/game-board.vala"
			break;
#line 1313 "game-board.c"
		}
#line 164 "../src/game-board.vala"
		_vala_row_1 = (guint8) (_vala_row_1 - 1);
#line 165 "../src/game-board.vala"
		_vala_col_1 = (guint8) (_vala_col_1 + 1);
#line 1319 "game-board.c"
	}
#line 167 "../src/game-board.vala"
	while (TRUE) {
#line 1323 "game-board.c"
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
#line 167 "../src/game-board.vala"
		if (((gint) _vala_col_2) > 0) {
#line 1328 "game-board.c"
			guint8 _tmp7_;
#line 167 "../src/game-board.vala"
			_tmp7_ = self->priv->_size;
#line 167 "../src/game-board.vala"
			_tmp6_ = ((gint) _vala_row_2) < (_tmp7_ - 1);
#line 1334 "game-board.c"
		} else {
#line 167 "../src/game-board.vala"
			_tmp6_ = FALSE;
#line 1338 "game-board.c"
		}
#line 167 "../src/game-board.vala"
		if (_tmp6_) {
#line 1342 "game-board.c"
			Player* _tmp8_;
			gint _tmp8__length1;
			gint _tmp8__length2;
			Player _tmp9_;
#line 167 "../src/game-board.vala"
			_tmp8_ = board_gboard;
#line 167 "../src/game-board.vala"
			_tmp8__length1 = board_gboard_length1;
#line 167 "../src/game-board.vala"
			_tmp8__length2 = board_gboard_length2;
#line 167 "../src/game-board.vala"
			_tmp9_ = _tmp8_[((_vala_row_2 + 1) * _tmp8__length2) + (_vala_col_2 - 1)];
#line 167 "../src/game-board.vala"
			_tmp5_ = _tmp9_ == tile;
#line 1357 "game-board.c"
		} else {
#line 167 "../src/game-board.vala"
			_tmp5_ = FALSE;
#line 1361 "game-board.c"
		}
#line 167 "../src/game-board.vala"
		if (!_tmp5_) {
#line 167 "../src/game-board.vala"
			break;
#line 1367 "game-board.c"
		}
#line 169 "../src/game-board.vala"
		_vala_row_2 = (guint8) (_vala_row_2 + 1);
#line 170 "../src/game-board.vala"
		_vala_col_2 = (guint8) (_vala_col_2 - 1);
#line 1373 "game-board.c"
	}
#line 172 "../src/game-board.vala"
	_tmp10_ = self->priv->_line;
#line 172 "../src/game-board.vala"
	result = ((gint) (_vala_row_2 - _vala_row_1)) >= (_tmp10_ - 1);
#line 172 "../src/game-board.vala"
	if (row_1) {
#line 172 "../src/game-board.vala"
		*row_1 = _vala_row_1;
#line 1383 "game-board.c"
	}
#line 172 "../src/game-board.vala"
	if (col_1) {
#line 172 "../src/game-board.vala"
		*col_1 = _vala_col_1;
#line 1389 "game-board.c"
	}
#line 172 "../src/game-board.vala"
	if (row_2) {
#line 172 "../src/game-board.vala"
		*row_2 = _vala_row_2;
#line 1395 "game-board.c"
	}
#line 172 "../src/game-board.vala"
	if (col_2) {
#line 172 "../src/game-board.vala"
		*col_2 = _vala_col_2;
#line 1401 "game-board.c"
	}
#line 172 "../src/game-board.vala"
	return result;
#line 1405 "game-board.c"
}

guint8
board_get_line (Board* self)
{
	guint8 result;
#line 23 "../src/game-board.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 23 "../src/game-board.vala"
	result = self->priv->_line;
#line 23 "../src/game-board.vala"
	return result;
#line 1418 "game-board.c"
}

static void
board_set_line (Board* self,
                guint8 value)
{
#line 23 "../src/game-board.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/game-board.vala"
	self->priv->_line = value;
#line 1429 "game-board.c"
}

guint8
board_get_size (Board* self)
{
	guint8 result;
#line 24 "../src/game-board.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 24 "../src/game-board.vala"
	result = self->priv->_size;
#line 24 "../src/game-board.vala"
	return result;
#line 1442 "game-board.c"
}

static void
board_set_size (Board* self,
                guint8 value)
{
#line 24 "../src/game-board.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/game-board.vala"
	self->priv->_size = value;
#line 1453 "game-board.c"
}

static GObject *
board_constructor (GType type,
                   guint n_construct_properties,
                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	Board * self;
	guint8 _tmp0_;
	guint8 _tmp1_;
	Player* _tmp2_;
#line 28 "../src/game-board.vala"
	parent_class = G_OBJECT_CLASS (board_parent_class);
#line 28 "../src/game-board.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 28 "../src/game-board.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BOARD, Board);
#line 30 "../src/game-board.vala"
	_tmp0_ = self->priv->_size;
#line 30 "../src/game-board.vala"
	_tmp1_ = self->priv->_size;
#line 30 "../src/game-board.vala"
	_tmp2_ = g_new0 (Player, _tmp0_ * _tmp1_);
#line 30 "../src/game-board.vala"
	board_gboard = (g_free (board_gboard), NULL);
#line 30 "../src/game-board.vala"
	board_gboard = _tmp2_;
#line 30 "../src/game-board.vala"
	board_gboard_length1 = _tmp0_;
#line 30 "../src/game-board.vala"
	board_gboard_length2 = _tmp1_;
#line 28 "../src/game-board.vala"
	return obj;
#line 1489 "game-board.c"
}

static void
board_class_init (BoardClass * klass,
                  gpointer klass_data)
{
#line 21 "../src/game-board.vala"
	board_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/game-board.vala"
	g_type_class_adjust_private_offset (klass, &Board_private_offset);
#line 21 "../src/game-board.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_board_get_property;
#line 21 "../src/game-board.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_board_set_property;
#line 21 "../src/game-board.vala"
	G_OBJECT_CLASS (klass)->constructor = board_constructor;
#line 21 "../src/game-board.vala"
	G_OBJECT_CLASS (klass)->finalize = board_finalize;
#line 21 "../src/game-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOARD_LINE_PROPERTY, board_properties[BOARD_LINE_PROPERTY] = g_param_spec_uchar ("line", "line", "line", 0, G_MAXUINT8, (guint8) 4, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/game-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOARD_SIZE_PROPERTY, board_properties[BOARD_SIZE_PROPERTY] = g_param_spec_uchar ("size", "size", "size", 0, G_MAXUINT8, (guint8) 7, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 1512 "game-board.c"
}

static void
board_instance_init (Board * self,
                     gpointer klass)
{
#line 21 "../src/game-board.vala"
	self->priv = board_get_instance_private (self);
#line 23 "../src/game-board.vala"
	self->priv->_line = (guint8) 4;
#line 24 "../src/game-board.vala"
	self->priv->_size = (guint8) 7;
#line 1525 "game-board.c"
}

static void
board_finalize (GObject * obj)
{
	Board * self;
#line 21 "../src/game-board.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BOARD, Board);
#line 21 "../src/game-board.vala"
	G_OBJECT_CLASS (board_parent_class)->finalize (obj);
#line 1536 "game-board.c"
}

static GType
board_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BoardClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) board_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Board), 0, (GInstanceInitFunc) board_instance_init, NULL };
	GType board_type_id;
	board_type_id = g_type_register_static (G_TYPE_OBJECT, "Board", &g_define_type_info, 0);
	Board_private_offset = g_type_add_instance_private (board_type_id, sizeof (BoardPrivate));
	return board_type_id;
}

GType
board_get_type (void)
{
	static volatile gsize board_type_id__once = 0;
	if (g_once_init_enter (&board_type_id__once)) {
		GType board_type_id;
		board_type_id = board_get_type_once ();
		g_once_init_leave (&board_type_id__once, board_type_id);
	}
	return board_type_id__once;
}

static void
_vala_board_get_property (GObject * object,
                          guint property_id,
                          GValue * value,
                          GParamSpec * pspec)
{
	Board * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BOARD, Board);
#line 21 "../src/game-board.vala"
	switch (property_id) {
#line 21 "../src/game-board.vala"
		case BOARD_LINE_PROPERTY:
#line 21 "../src/game-board.vala"
		g_value_set_uchar (value, board_get_line (self));
#line 21 "../src/game-board.vala"
		break;
#line 21 "../src/game-board.vala"
		case BOARD_SIZE_PROPERTY:
#line 21 "../src/game-board.vala"
		g_value_set_uchar (value, board_get_size (self));
#line 21 "../src/game-board.vala"
		break;
#line 1583 "game-board.c"
		default:
#line 21 "../src/game-board.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/game-board.vala"
		break;
#line 1589 "game-board.c"
	}
}

static void
_vala_board_set_property (GObject * object,
                          guint property_id,
                          const GValue * value,
                          GParamSpec * pspec)
{
	Board * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BOARD, Board);
#line 21 "../src/game-board.vala"
	switch (property_id) {
#line 21 "../src/game-board.vala"
		case BOARD_LINE_PROPERTY:
#line 21 "../src/game-board.vala"
		board_set_line (self, g_value_get_uchar (value));
#line 21 "../src/game-board.vala"
		break;
#line 21 "../src/game-board.vala"
		case BOARD_SIZE_PROPERTY:
#line 21 "../src/game-board.vala"
		board_set_size (self, g_value_get_uchar (value));
#line 21 "../src/game-board.vala"
		break;
#line 1615 "game-board.c"
		default:
#line 21 "../src/game-board.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/game-board.vala"
		break;
#line 1621 "game-board.c"
	}
}

