/* game-window.c generated by valac 0.56.14, the Vala compiler
 * generated from game-window.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Four-in-a-row.

   Copyright © 2015, 2016, 2019 Arnaud Bonatti

   GNOME Four-in-a-row is free software: you can redistribute it and/or
   modify it under the terms of the GNU General Public License as published
   by the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Four-in-a-row is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with GNOME Four-in-a-row.  If not, see <https://www.gnu.org/licenses/>.
*/
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	GAME_WINDOW_FLAGS_SHOW_UNDO = 1 << 0,
	GAME_WINDOW_FLAGS_SHOW_START_BUTTON = 1 << 1
} GameWindowFlags;

#define TYPE_GAME_WINDOW_FLAGS (game_window_flags_get_type ())

#define TYPE_ADAPTATIVE_WINDOW (adaptative_window_get_type ())
#define ADAPTATIVE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADAPTATIVE_WINDOW, AdaptativeWindow))
#define ADAPTATIVE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ADAPTATIVE_WINDOW, AdaptativeWindowClass))
#define IS_ADAPTATIVE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADAPTATIVE_WINDOW))
#define IS_ADAPTATIVE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ADAPTATIVE_WINDOW))
#define ADAPTATIVE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ADAPTATIVE_WINDOW, AdaptativeWindowClass))

typedef struct _AdaptativeWindow AdaptativeWindow;
typedef struct _AdaptativeWindowClass AdaptativeWindowClass;
typedef struct _AdaptativeWindowPrivate AdaptativeWindowPrivate;

#define TYPE_ADAPTATIVE_WIDGET (adaptative_widget_get_type ())
#define ADAPTATIVE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADAPTATIVE_WIDGET, AdaptativeWidget))
#define IS_ADAPTATIVE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADAPTATIVE_WIDGET))
#define ADAPTATIVE_WIDGET_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_ADAPTATIVE_WIDGET, AdaptativeWidgetIface))

typedef struct _AdaptativeWidget AdaptativeWidget;
typedef struct _AdaptativeWidgetIface AdaptativeWidgetIface;
typedef enum  {
	ADAPTATIVE_WIDGET_WINDOW_SIZE_START_SIZE,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_USUAL_SIZE,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_QUITE_THIN,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_VERT,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_HZTL,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_BOTH,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_THIN,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_FLAT
} AdaptativeWidgetWindowSize;

#define ADAPTATIVE_WIDGET_TYPE_WINDOW_SIZE (adaptative_widget_window_size_get_type ())

#define TYPE_GAME_WINDOW (game_window_get_type ())
#define GAME_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_WINDOW, GameWindow))
#define GAME_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_WINDOW, GameWindowClass))
#define IS_GAME_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_WINDOW))
#define IS_GAME_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_WINDOW))
#define GAME_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_WINDOW, GameWindowClass))

typedef struct _GameWindow GameWindow;
typedef struct _GameWindowClass GameWindowClass;
typedef struct _GameWindowPrivate GameWindowPrivate;

#define TYPE_GAME_ACTION_BAR (game_action_bar_get_type ())
#define GAME_ACTION_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_ACTION_BAR, GameActionBar))
#define GAME_ACTION_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_ACTION_BAR, GameActionBarClass))
#define IS_GAME_ACTION_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_ACTION_BAR))
#define IS_GAME_ACTION_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_ACTION_BAR))
#define GAME_ACTION_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_ACTION_BAR, GameActionBarClass))

typedef struct _GameActionBar GameActionBar;
typedef struct _GameActionBarClass GameActionBarClass;
enum  {
	GAME_WINDOW_0_PROPERTY,
	GAME_WINDOW_IS_EXTRA_THIN_PROPERTY,
	GAME_WINDOW_NUM_PROPERTIES
};
static GParamSpec* game_window_properties[GAME_WINDOW_NUM_PROPERTIES];
typedef void (*GSimpleActionActivateCallback) (GSimpleAction* action, GVariant* parameter, gpointer user_data);
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_GAME_ACTION_BAR_PLACE_HOLDER (game_action_bar_place_holder_get_type ())
#define GAME_ACTION_BAR_PLACE_HOLDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_ACTION_BAR_PLACE_HOLDER, GameActionBarPlaceHolder))
#define GAME_ACTION_BAR_PLACE_HOLDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_ACTION_BAR_PLACE_HOLDER, GameActionBarPlaceHolderClass))
#define IS_GAME_ACTION_BAR_PLACE_HOLDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_ACTION_BAR_PLACE_HOLDER))
#define IS_GAME_ACTION_BAR_PLACE_HOLDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_ACTION_BAR_PLACE_HOLDER))
#define GAME_ACTION_BAR_PLACE_HOLDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_ACTION_BAR_PLACE_HOLDER, GameActionBarPlaceHolderClass))

typedef struct _GameActionBarPlaceHolder GameActionBarPlaceHolder;
typedef struct _GameActionBarPlaceHolderClass GameActionBarPlaceHolderClass;
enum  {
	GAME_WINDOW_PLAY_SIGNAL,
	GAME_WINDOW_WAIT_SIGNAL,
	GAME_WINDOW_BACK_SIGNAL,
	GAME_WINDOW_UNDO_SIGNAL,
	GAME_WINDOW_HINT_SIGNAL,
	GAME_WINDOW_NUM_SIGNALS
};
static guint game_window_signals[GAME_WINDOW_NUM_SIGNALS] = {0};

struct _AdaptativeWindow {
	GtkApplicationWindow parent_instance;
	AdaptativeWindowPrivate * priv;
};

struct _AdaptativeWindowClass {
	GtkApplicationWindowClass parent_class;
	void (*on_fullscreen) (AdaptativeWindow* self);
	void (*on_unfullscreen) (AdaptativeWindow* self);
	void (*before_destroy) (AdaptativeWindow* self);
};

struct _AdaptativeWidgetIface {
	GTypeInterface parent_iface;
	void (*set_window_size) (AdaptativeWidget* self, AdaptativeWidgetWindowSize new_size);
};

struct _GameWindow {
	AdaptativeWindow parent_instance;
	GameWindowPrivate * priv;
};

struct _GameWindowClass {
	AdaptativeWindowClass parent_class;
};

struct _GameWindowPrivate {
	gboolean game_finished;
	gchar* program_name;
	GtkHeaderBar* headerbar;
	GtkOverlay* overlay;
	GtkStack* stack;
	GtkButton* start_game_button;
	GtkButton* new_game_button;
	GtkButton* back_button;
	GtkButton* unfullscreen_button;
	GtkBox* game_box;
	GtkBox* new_game_box;
	GtkWidget* view;
	GtkWidget* game_widget_1;
	GameActionBar* actionbar;
	GSimpleAction* back_action;
	GSimpleAction* undo_action;
	GSimpleAction* hint_action;
	gboolean _is_extra_thin;
	gboolean is_quite_thin;
	gchar* last_subtitle;
	GtkMenuButton* info_button;
};

static gint GameWindow_private_offset;
static gpointer game_window_parent_class = NULL;
static AdaptativeWidgetIface * game_window_adaptative_widget_parent_iface = NULL;

VALA_EXTERN GType game_window_flags_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType adaptative_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AdaptativeWindow, g_object_unref)
VALA_EXTERN GType adaptative_widget_window_size_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType adaptative_widget_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AdaptativeWidget, g_object_unref)
VALA_EXTERN GType game_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameWindow, g_object_unref)
VALA_EXTERN GType game_action_bar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameActionBar, g_object_unref)
VALA_EXTERN void adaptative_window_on_fullscreen (AdaptativeWindow* self);
VALA_EXTERN void adaptative_window_on_unfullscreen (AdaptativeWindow* self);
static void game_window_new_game_cb (GameWindow* self);
static void _game_window_new_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self);
static void game_window_start_game_cb (GameWindow* self);
static void _game_window_start_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self);
static void game_window_back_cb (GameWindow* self);
static void _game_window_back_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self);
static void game_window_undo_cb (GameWindow* self);
static void _game_window_undo_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self);
static void game_window_hint_cb (GameWindow* self);
static void _game_window_hint_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self);
static inline void game_window_toggle_hamburger (GameWindow* self);
static void _game_window_toggle_hamburger_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self);
static void _gtk_window_unfullscreen_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self);
VALA_EXTERN GameWindow* game_window_new (const gchar* css_resource,
                             const gchar* name,
                             gboolean start_now,
                             GameWindowFlags flags,
                             GtkBox* new_game_screen,
                             GtkWidget* _view,
                             GMenu* app_menu,
                             GtkWidget* _game_widget_1,
                             GtkWidget* game_widget_2);
VALA_EXTERN GameWindow* game_window_construct (GType object_type,
                                   const gchar* css_resource,
                                   const gchar* name,
                                   gboolean start_now,
                                   GameWindowFlags flags,
                                   GtkBox* new_game_screen,
                                   GtkWidget* _view,
                                   GMenu* app_menu,
                                   GtkWidget* _game_widget_1,
                                   GtkWidget* game_widget_2);
static void game_window_install_ui_action_entries (GameWindow* self);
VALA_EXTERN gboolean game_window_get_is_extra_thin (GameWindow* self);
VALA_EXTERN void adaptative_window_add_adaptative_child (AdaptativeWindow* self,
                                             AdaptativeWidget* child);
VALA_EXTERN GameActionBar* game_action_bar_new (const gchar* _game_name,
                                    GtkWidget* _game_widget,
                                    gboolean _show_actionbar);
VALA_EXTERN GameActionBar* game_action_bar_construct (GType object_type,
                                          const gchar* _game_name,
                                          GtkWidget* _game_widget,
                                          gboolean _show_actionbar);
VALA_EXTERN GType game_action_bar_place_holder_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameActionBarPlaceHolder, g_object_unref)
VALA_EXTERN GameActionBarPlaceHolder* game_action_bar_place_holder_new (GameActionBar* _actionbar);
VALA_EXTERN GameActionBarPlaceHolder* game_action_bar_place_holder_construct (GType object_type,
                                                                  GameActionBar* _actionbar);
static void game_window_show_view (GameWindow* self);
static void game_window_show_new_game_screen (GameWindow* self);
static void game_window_real_on_fullscreen (AdaptativeWindow* base);
static void game_window_real_on_unfullscreen (AdaptativeWindow* base);
VALA_EXTERN void game_window_cannot_undo_more (GameWindow* self);
VALA_EXTERN void game_window_set_subtitle (GameWindow* self,
                               const gchar* subtitle);
VALA_EXTERN void game_action_bar_set_visibility (GameActionBar* self,
                                     gboolean new_visibility);
VALA_EXTERN void game_action_bar_update_title (GameActionBar* self,
                                   const gchar* new_title);
VALA_EXTERN void game_window_finish_game (GameWindow* self);
VALA_EXTERN void game_window_allow_hint (GameWindow* self,
                             gboolean allow);
VALA_EXTERN void game_window_allow_undo (GameWindow* self,
                             gboolean allow);
static void game_window_real_set_window_size (AdaptativeWidget* base,
                                       AdaptativeWidgetWindowSize new_size);
VALA_EXTERN gboolean adaptative_widget_window_size_is_quite_thin (AdaptativeWidgetWindowSize window_size);
VALA_EXTERN gboolean adaptative_widget_window_size_is_extra_thin (AdaptativeWidgetWindowSize window_size);
static void game_window_set_is_extra_thin (GameWindow* self,
                                    gboolean value);
VALA_EXTERN gboolean game_window_new_game_screen_visible (GameWindow* self);
VALA_EXTERN void game_window_close_hamburger (GameWindow* self);
VALA_EXTERN void adaptative_widget_set_window_size (AdaptativeWidget* self,
                                        AdaptativeWidgetWindowSize new_size);
static void game_window_finalize (GObject * obj);
static GType game_window_get_type_once (void);
static void _vala_game_window_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_game_window_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static const GActionEntry GAME_WINDOW_ui_action_entries[7] = {{"new-game", _game_window_new_game_cb_gsimple_action_activate_callback}, {"start-game", _game_window_start_game_cb_gsimple_action_activate_callback}, {"back", _game_window_back_cb_gsimple_action_activate_callback}, {"undo", _game_window_undo_cb_gsimple_action_activate_callback}, {"hint", _game_window_hint_cb_gsimple_action_activate_callback}, {"toggle-hamburger", _game_window_toggle_hamburger_gsimple_action_activate_callback}, {"unfullscreen", _gtk_window_unfullscreen_gsimple_action_activate_callback}};

static GType
game_window_flags_get_type_once (void)
{
	static const GFlagsValue values[] = {{GAME_WINDOW_FLAGS_SHOW_UNDO, "GAME_WINDOW_FLAGS_SHOW_UNDO", "show-undo"}, {GAME_WINDOW_FLAGS_SHOW_START_BUTTON, "GAME_WINDOW_FLAGS_SHOW_START_BUTTON", "show-start-button"}, {0, NULL, NULL}};
	GType game_window_flags_type_id;
	game_window_flags_type_id = g_flags_register_static ("GameWindowFlags", values);
	return game_window_flags_type_id;
}

GType
game_window_flags_get_type (void)
{
	static volatile gsize game_window_flags_type_id__once = 0;
	if (g_once_init_enter (&game_window_flags_type_id__once)) {
		GType game_window_flags_type_id;
		game_window_flags_type_id = game_window_flags_get_type_once ();
		g_once_init_leave (&game_window_flags_type_id__once, game_window_flags_type_id);
	}
	return game_window_flags_type_id__once;
}

static inline gpointer
game_window_get_instance_private (GameWindow* self)
{
	return G_STRUCT_MEMBER_P (self, GameWindow_private_offset);
}

static void
_game_window_new_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self)
{
#line 166 "../src/game-window.vala"
	game_window_new_game_cb ((GameWindow*) self);
#line 338 "game-window.c"
}

static void
_game_window_start_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                             GVariant* parameter,
                                                             gpointer self)
{
#line 166 "../src/game-window.vala"
	game_window_start_game_cb ((GameWindow*) self);
#line 348 "game-window.c"
}

static void
_game_window_back_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                       GVariant* parameter,
                                                       gpointer self)
{
#line 166 "../src/game-window.vala"
	game_window_back_cb ((GameWindow*) self);
#line 358 "game-window.c"
}

static void
_game_window_undo_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                       GVariant* parameter,
                                                       gpointer self)
{
#line 166 "../src/game-window.vala"
	game_window_undo_cb ((GameWindow*) self);
#line 368 "game-window.c"
}

static void
_game_window_hint_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                       GVariant* parameter,
                                                       gpointer self)
{
#line 166 "../src/game-window.vala"
	game_window_hint_cb ((GameWindow*) self);
#line 378 "game-window.c"
}

static void
_game_window_toggle_hamburger_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self)
{
#line 166 "../src/game-window.vala"
	game_window_toggle_hamburger ((GameWindow*) self);
#line 388 "game-window.c"
}

static void
_gtk_window_unfullscreen_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self)
{
#line 166 "../src/game-window.vala"
	gtk_window_unfullscreen ((GtkWindow*) self);
#line 398 "game-window.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 74 "../src/game-window.vala"
	return self ? g_object_ref (self) : NULL;
#line 406 "game-window.c"
}

GameWindow*
game_window_construct (GType object_type,
                       const gchar* css_resource,
                       const gchar* name,
                       gboolean start_now,
                       GameWindowFlags flags,
                       GtkBox* new_game_screen,
                       GtkWidget* _view,
                       GMenu* app_menu,
                       GtkWidget* _game_widget_1,
                       GtkWidget* game_widget_2)
{
	GameWindow * self = NULL;
	GtkWidget* _tmp7_;
	GtkWidget* _tmp8_;
	gchar* _tmp9_;
	gboolean _tmp10_;
	GtkMenuButton* _tmp12_;
	GtkWidget* _tmp13_;
	GameActionBar* _tmp17_;
	GameActionBar* _tmp18_;
	GameActionBar* _tmp19_;
	GtkOverlay* _tmp20_;
	GameActionBar* _tmp21_;
	GameActionBarPlaceHolder* actionbar_placeholder = NULL;
	GameActionBar* _tmp22_;
	GameActionBarPlaceHolder* _tmp23_;
	GameActionBarPlaceHolder* _tmp24_;
	GtkBox* _tmp25_;
	GameActionBarPlaceHolder* _tmp26_;
	GtkBox* _tmp27_;
	GameActionBar* _tmp28_;
	GameActionBarPlaceHolder* _tmp29_;
	GtkBox* _tmp42_;
	GtkWidget* _tmp43_;
	GtkBox* _tmp44_;
	GtkWidget* _tmp45_;
	GtkWidget* _tmp46_;
	GtkWidget* _tmp47_;
	GtkWidget* _tmp48_;
#line 64 "../src/game-window.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 64 "../src/game-window.vala"
	g_return_val_if_fail (new_game_screen != NULL, NULL);
#line 64 "../src/game-window.vala"
	g_return_val_if_fail (_view != NULL, NULL);
#line 64 "../src/game-window.vala"
	g_return_val_if_fail (app_menu != NULL, NULL);
#line 66 "../src/game-window.vala"
	self = (GameWindow*) g_object_new (object_type, "window-title", name, "specific-css-class-or-empty", "", "schema-path", "/org/gnome/Four-in-a-row/", NULL);
#line 70 "../src/game-window.vala"
	if (css_resource != NULL) {
#line 461 "game-window.c"
		GtkCssProvider* css_provider = NULL;
		GtkCssProvider* _tmp0_;
		GtkCssProvider* _tmp1_;
		GdkScreen* gdk_screen = NULL;
		GdkScreen* _tmp2_;
		GdkScreen* _tmp3_;
		GdkScreen* _tmp4_;
#line 72 "../src/game-window.vala"
		_tmp0_ = gtk_css_provider_new ();
#line 72 "../src/game-window.vala"
		css_provider = _tmp0_;
#line 73 "../src/game-window.vala"
		_tmp1_ = css_provider;
#line 73 "../src/game-window.vala"
		gtk_css_provider_load_from_resource (_tmp1_, (const gchar*) css_resource);
#line 74 "../src/game-window.vala"
		_tmp2_ = gdk_screen_get_default ();
#line 74 "../src/game-window.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 74 "../src/game-window.vala"
		gdk_screen = _tmp3_;
#line 75 "../src/game-window.vala"
		_tmp4_ = gdk_screen;
#line 75 "../src/game-window.vala"
		if (_tmp4_ != NULL) {
#line 487 "game-window.c"
			GdkScreen* _tmp5_;
			GtkCssProvider* _tmp6_;
#line 76 "../src/game-window.vala"
			_tmp5_ = gdk_screen;
#line 76 "../src/game-window.vala"
			_tmp6_ = css_provider;
#line 76 "../src/game-window.vala"
			gtk_style_context_add_provider_for_screen (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gdk_screen_get_type (), GdkScreen), (GtkStyleProvider*) _tmp6_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 496 "game-window.c"
		}
#line 70 "../src/game-window.vala"
		_g_object_unref0 (gdk_screen);
#line 70 "../src/game-window.vala"
		_g_object_unref0 (css_provider);
#line 502 "game-window.c"
	}
#line 79 "../src/game-window.vala"
	_tmp7_ = _g_object_ref0 (_view);
#line 79 "../src/game-window.vala"
	_g_object_unref0 (self->priv->view);
#line 79 "../src/game-window.vala"
	self->priv->view = _tmp7_;
#line 80 "../src/game-window.vala"
	_tmp8_ = _g_object_ref0 (_game_widget_1);
#line 80 "../src/game-window.vala"
	_g_object_unref0 (self->priv->game_widget_1);
#line 80 "../src/game-window.vala"
	self->priv->game_widget_1 = _tmp8_;
#line 83 "../src/game-window.vala"
	game_window_install_ui_action_entries (self);
#line 84 "../src/game-window.vala"
	_tmp9_ = g_strdup (name);
#line 84 "../src/game-window.vala"
	_g_free0 (self->priv->program_name);
#line 84 "../src/game-window.vala"
	self->priv->program_name = _tmp9_;
#line 85 "../src/game-window.vala"
	gtk_window_set_title ((GtkWindow*) self, name);
#line 86 "../src/game-window.vala"
	_tmp10_ = self->priv->_is_extra_thin;
#line 86 "../src/game-window.vala"
	if (!_tmp10_) {
#line 530 "game-window.c"
		GtkHeaderBar* _tmp11_;
#line 87 "../src/game-window.vala"
		_tmp11_ = self->priv->headerbar;
#line 87 "../src/game-window.vala"
		gtk_header_bar_set_title (_tmp11_, name);
#line 536 "game-window.c"
	}
#line 88 "../src/game-window.vala"
	_tmp12_ = self->priv->info_button;
#line 88 "../src/game-window.vala"
	gtk_menu_button_set_menu_model (_tmp12_, (GMenuModel*) app_menu);
#line 91 "../src/game-window.vala"
	_tmp13_ = self->priv->game_widget_1;
#line 91 "../src/game-window.vala"
	if (_tmp13_ != NULL) {
#line 546 "game-window.c"
		GtkHeaderBar* _tmp14_;
		GtkWidget* _tmp15_;
		GtkWidget* _tmp16_;
#line 93 "../src/game-window.vala"
		_tmp14_ = self->priv->headerbar;
#line 93 "../src/game-window.vala"
		_tmp15_ = self->priv->game_widget_1;
#line 93 "../src/game-window.vala"
		gtk_header_bar_pack_end (_tmp14_, G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_widget_get_type (), GtkWidget));
#line 94 "../src/game-window.vala"
		_tmp16_ = self->priv->game_widget_1;
#line 94 "../src/game-window.vala"
		adaptative_window_add_adaptative_child ((AdaptativeWindow*) self, G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_widget_get_type (), GtkWidget), TYPE_ADAPTATIVE_WIDGET, AdaptativeWidget));
#line 560 "game-window.c"
	}
#line 96 "../src/game-window.vala"
	_tmp17_ = game_action_bar_new (name, game_widget_2, start_now);
#line 96 "../src/game-window.vala"
	g_object_ref_sink (_tmp17_);
#line 96 "../src/game-window.vala"
	_g_object_unref0 (self->priv->actionbar);
#line 96 "../src/game-window.vala"
	self->priv->actionbar = _tmp17_;
#line 97 "../src/game-window.vala"
	_tmp18_ = self->priv->actionbar;
#line 97 "../src/game-window.vala"
	gtk_widget_show ((GtkWidget*) _tmp18_);
#line 98 "../src/game-window.vala"
	_tmp19_ = self->priv->actionbar;
#line 98 "../src/game-window.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp19_, GTK_ALIGN_END);
#line 99 "../src/game-window.vala"
	_tmp20_ = self->priv->overlay;
#line 99 "../src/game-window.vala"
	_tmp21_ = self->priv->actionbar;
#line 99 "../src/game-window.vala"
	gtk_overlay_add_overlay (_tmp20_, (GtkWidget*) _tmp21_);
#line 101 "../src/game-window.vala"
	_tmp22_ = self->priv->actionbar;
#line 101 "../src/game-window.vala"
	_tmp23_ = game_action_bar_place_holder_new (_tmp22_);
#line 101 "../src/game-window.vala"
	g_object_ref_sink (_tmp23_);
#line 101 "../src/game-window.vala"
	actionbar_placeholder = _tmp23_;
#line 102 "../src/game-window.vala"
	_tmp24_ = actionbar_placeholder;
#line 102 "../src/game-window.vala"
	gtk_widget_show ((GtkWidget*) _tmp24_);
#line 103 "../src/game-window.vala"
	_tmp25_ = self->priv->game_box;
#line 103 "../src/game-window.vala"
	_tmp26_ = actionbar_placeholder;
#line 103 "../src/game-window.vala"
	gtk_box_pack_end (_tmp25_, (GtkWidget*) _tmp26_, FALSE, TRUE, (guint) 0);
#line 105 "../src/game-window.vala"
	_tmp27_ = self->priv->new_game_box;
#line 105 "../src/game-window.vala"
	gtk_box_pack_start (_tmp27_, (GtkWidget*) new_game_screen, TRUE, TRUE, (guint) 0);
#line 106 "../src/game-window.vala"
	adaptative_window_add_adaptative_child ((AdaptativeWindow*) self, G_TYPE_CHECK_INSTANCE_CAST (new_game_screen, TYPE_ADAPTATIVE_WIDGET, AdaptativeWidget));
#line 107 "../src/game-window.vala"
	_tmp28_ = self->priv->actionbar;
#line 107 "../src/game-window.vala"
	adaptative_window_add_adaptative_child ((AdaptativeWindow*) self, G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, TYPE_ADAPTATIVE_WIDGET, AdaptativeWidget));
#line 108 "../src/game-window.vala"
	_tmp29_ = actionbar_placeholder;
#line 108 "../src/game-window.vala"
	adaptative_window_add_adaptative_child ((AdaptativeWindow*) self, G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, TYPE_ADAPTATIVE_WIDGET, AdaptativeWidget));
#line 109 "../src/game-window.vala"
	adaptative_window_add_adaptative_child ((AdaptativeWindow*) self, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_ADAPTATIVE_WIDGET, AdaptativeWidget));
#line 110 "../src/game-window.vala"
	if ((flags & GAME_WINDOW_FLAGS_SHOW_START_BUTTON) == GAME_WINDOW_FLAGS_SHOW_START_BUTTON) {
#line 620 "game-window.c"
		GtkButton* _start_game_button = NULL;
		GtkButton* _tmp30_;
		GtkButton* _tmp31_;
		GtkStyleContext* _tmp32_;
		GtkButton* _tmp33_;
		GtkButton* _tmp34_;
		GtkButton* _tmp35_;
		GtkStyleContext* _tmp36_;
		GtkButton* _tmp37_;
		GtkBox* _tmp38_;
		GtkButton* _tmp39_;
		GtkButton* _tmp40_;
		GtkButton* _tmp41_;
#line 113 "../src/game-window.vala"
		_tmp30_ = (GtkButton*) gtk_button_new_with_mnemonic (_ ("_Start Game"));
#line 113 "../src/game-window.vala"
		g_object_ref_sink (_tmp30_);
#line 113 "../src/game-window.vala"
		_start_game_button = _tmp30_;
#line 116 "../src/game-window.vala"
		_tmp31_ = _start_game_button;
#line 116 "../src/game-window.vala"
		_tmp32_ = gtk_widget_get_style_context ((GtkWidget*) _tmp31_);
#line 116 "../src/game-window.vala"
		gtk_style_context_add_class (_tmp32_, "start-game-button");
#line 117 "../src/game-window.vala"
		_tmp33_ = _start_game_button;
#line 117 "../src/game-window.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp33_, GTK_ALIGN_CENTER);
#line 118 "../src/game-window.vala"
		_tmp34_ = _start_game_button;
#line 118 "../src/game-window.vala"
		gtk_actionable_set_action_name ((GtkActionable*) _tmp34_, "ui.start-game");
#line 121 "../src/game-window.vala"
		_tmp35_ = _start_game_button;
#line 121 "../src/game-window.vala"
		_tmp36_ = gtk_widget_get_style_context ((GtkWidget*) _tmp35_);
#line 121 "../src/game-window.vala"
		gtk_style_context_add_class (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, gtk_style_context_get_type (), GtkStyleContext), "suggested-action");
#line 122 "../src/game-window.vala"
		_tmp37_ = _start_game_button;
#line 122 "../src/game-window.vala"
		gtk_widget_show ((GtkWidget*) _tmp37_);
#line 123 "../src/game-window.vala"
		_tmp38_ = self->priv->new_game_box;
#line 123 "../src/game-window.vala"
		_tmp39_ = _start_game_button;
#line 123 "../src/game-window.vala"
		gtk_box_pack_end (_tmp38_, (GtkWidget*) _tmp39_, FALSE, FALSE, (guint) 0);
#line 124 "../src/game-window.vala"
		_tmp40_ = _start_game_button;
#line 124 "../src/game-window.vala"
		_tmp41_ = _g_object_ref0 (_tmp40_);
#line 124 "../src/game-window.vala"
		_g_object_unref0 (self->priv->start_game_button);
#line 124 "../src/game-window.vala"
		self->priv->start_game_button = _tmp41_;
#line 110 "../src/game-window.vala"
		_g_object_unref0 (_start_game_button);
#line 680 "game-window.c"
	}
#line 127 "../src/game-window.vala"
	_tmp42_ = self->priv->game_box;
#line 127 "../src/game-window.vala"
	_tmp43_ = self->priv->view;
#line 127 "../src/game-window.vala"
	gtk_box_pack_start (_tmp42_, _tmp43_, TRUE, TRUE, (guint) 0);
#line 128 "../src/game-window.vala"
	_tmp44_ = self->priv->game_box;
#line 128 "../src/game-window.vala"
	_tmp45_ = self->priv->view;
#line 128 "../src/game-window.vala"
	gtk_container_set_focus_child ((GtkContainer*) _tmp44_, _tmp45_);
#line 129 "../src/game-window.vala"
	_tmp46_ = self->priv->view;
#line 129 "../src/game-window.vala"
	gtk_widget_set_halign (_tmp46_, GTK_ALIGN_FILL);
#line 130 "../src/game-window.vala"
	_tmp47_ = self->priv->view;
#line 130 "../src/game-window.vala"
	gtk_widget_set_can_focus (_tmp47_, TRUE);
#line 131 "../src/game-window.vala"
	_tmp48_ = self->priv->view;
#line 131 "../src/game-window.vala"
	gtk_widget_show (_tmp48_);
#line 134 "../src/game-window.vala"
	if (start_now) {
#line 135 "../src/game-window.vala"
		game_window_show_view (self);
#line 710 "game-window.c"
	} else {
#line 137 "../src/game-window.vala"
		game_window_show_new_game_screen (self);
#line 714 "game-window.c"
	}
#line 64 "../src/game-window.vala"
	_g_object_unref0 (actionbar_placeholder);
#line 64 "../src/game-window.vala"
	return self;
#line 720 "game-window.c"
}

GameWindow*
game_window_new (const gchar* css_resource,
                 const gchar* name,
                 gboolean start_now,
                 GameWindowFlags flags,
                 GtkBox* new_game_screen,
                 GtkWidget* _view,
                 GMenu* app_menu,
                 GtkWidget* _game_widget_1,
                 GtkWidget* game_widget_2)
{
#line 64 "../src/game-window.vala"
	return game_window_construct (TYPE_GAME_WINDOW, css_resource, name, start_now, flags, new_game_screen, _view, app_menu, _game_widget_1, game_widget_2);
#line 736 "game-window.c"
}

static void
game_window_install_ui_action_entries (GameWindow* self)
{
	GSimpleActionGroup* action_group = NULL;
	GSimpleActionGroup* _tmp0_;
	GAction* _tmp1_;
	GSimpleAction* _tmp2_;
	GAction* _tmp3_;
	GSimpleAction* _tmp4_;
	GAction* _tmp5_;
	GSimpleAction* _tmp6_;
	GSimpleAction* _tmp7_;
	GSimpleAction* _tmp8_;
	GSimpleAction* _tmp9_;
#line 149 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 151 "../src/game-window.vala"
	_tmp0_ = g_simple_action_group_new ();
#line 151 "../src/game-window.vala"
	action_group = _tmp0_;
#line 152 "../src/game-window.vala"
	g_action_map_add_action_entries ((GActionMap*) action_group, GAME_WINDOW_ui_action_entries, (gint) G_N_ELEMENTS (GAME_WINDOW_ui_action_entries), self);
#line 153 "../src/game-window.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "ui", (GActionGroup*) action_group);
#line 155 "../src/game-window.vala"
	_tmp1_ = g_action_map_lookup_action ((GActionMap*) action_group, "back");
#line 155 "../src/game-window.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_simple_action_get_type (), GSimpleAction));
#line 155 "../src/game-window.vala"
	_g_object_unref0 (self->priv->back_action);
#line 155 "../src/game-window.vala"
	self->priv->back_action = _tmp2_;
#line 156 "../src/game-window.vala"
	_tmp3_ = g_action_map_lookup_action ((GActionMap*) action_group, "undo");
#line 156 "../src/game-window.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_simple_action_get_type (), GSimpleAction));
#line 156 "../src/game-window.vala"
	_g_object_unref0 (self->priv->undo_action);
#line 156 "../src/game-window.vala"
	self->priv->undo_action = _tmp4_;
#line 158 "../src/game-window.vala"
	_tmp5_ = g_action_map_lookup_action ((GActionMap*) action_group, "hint");
#line 158 "../src/game-window.vala"
	_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, g_simple_action_get_type (), GSimpleAction));
#line 158 "../src/game-window.vala"
	_g_object_unref0 (self->priv->hint_action);
#line 158 "../src/game-window.vala"
	self->priv->hint_action = _tmp6_;
#line 160 "../src/game-window.vala"
	_tmp7_ = self->priv->back_action;
#line 160 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp7_, FALSE);
#line 161 "../src/game-window.vala"
	_tmp8_ = self->priv->undo_action;
#line 161 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp8_, FALSE);
#line 163 "../src/game-window.vala"
	_tmp9_ = self->priv->hint_action;
#line 163 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp9_, FALSE);
#line 149 "../src/game-window.vala"
	_g_object_unref0 (action_group);
#line 801 "game-window.c"
}

static void
game_window_real_on_fullscreen (AdaptativeWindow* base)
{
	GameWindow * self;
	GtkButton* _tmp0_;
#line 184 "../src/game-window.vala"
	self = (GameWindow*) base;
#line 186 "../src/game-window.vala"
	_tmp0_ = self->priv->unfullscreen_button;
#line 186 "../src/game-window.vala"
	gtk_widget_show ((GtkWidget*) _tmp0_);
#line 815 "game-window.c"
}

static void
game_window_real_on_unfullscreen (AdaptativeWindow* base)
{
	GameWindow * self;
	GtkButton* _tmp0_;
#line 189 "../src/game-window.vala"
	self = (GameWindow*) base;
#line 191 "../src/game-window.vala"
	_tmp0_ = self->priv->unfullscreen_button;
#line 191 "../src/game-window.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 829 "game-window.c"
}

void
game_window_cannot_undo_more (GameWindow* self)
{
	GSimpleAction* _tmp0_;
	GtkWidget* _tmp1_;
#line 198 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 200 "../src/game-window.vala"
	_tmp0_ = self->priv->undo_action;
#line 200 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp0_, FALSE);
#line 201 "../src/game-window.vala"
	_tmp1_ = self->priv->view;
#line 201 "../src/game-window.vala"
	gtk_widget_grab_focus (_tmp1_);
#line 847 "game-window.c"
}

void
game_window_set_subtitle (GameWindow* self,
                          const gchar* subtitle)
{
	gboolean _tmp0_;
	gchar* _tmp2_;
#line 210 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 212 "../src/game-window.vala"
	_tmp0_ = self->priv->_is_extra_thin;
#line 212 "../src/game-window.vala"
	if (!_tmp0_) {
#line 862 "game-window.c"
		GtkHeaderBar* _tmp1_;
#line 213 "../src/game-window.vala"
		_tmp1_ = self->priv->headerbar;
#line 213 "../src/game-window.vala"
		gtk_header_bar_set_title (_tmp1_, subtitle);
#line 868 "game-window.c"
	}
#line 214 "../src/game-window.vala"
	_tmp2_ = g_strdup (subtitle);
#line 214 "../src/game-window.vala"
	_g_free0 (self->priv->last_subtitle);
#line 214 "../src/game-window.vala"
	self->priv->last_subtitle = _tmp2_;
#line 215 "../src/game-window.vala"
	if (subtitle == NULL) {
#line 878 "game-window.c"
		GameActionBar* _tmp3_;
#line 216 "../src/game-window.vala"
		_tmp3_ = self->priv->actionbar;
#line 216 "../src/game-window.vala"
		game_action_bar_set_visibility (_tmp3_, FALSE);
#line 884 "game-window.c"
	} else {
		GameActionBar* _tmp4_;
		GameActionBar* _tmp5_;
#line 219 "../src/game-window.vala"
		_tmp4_ = self->priv->actionbar;
#line 219 "../src/game-window.vala"
		game_action_bar_update_title (_tmp4_, (const gchar*) subtitle);
#line 220 "../src/game-window.vala"
		_tmp5_ = self->priv->actionbar;
#line 220 "../src/game-window.vala"
		game_action_bar_set_visibility (_tmp5_, TRUE);
#line 896 "game-window.c"
	}
}

void
game_window_finish_game (GameWindow* self)
{
	GtkButton* _tmp0_;
#line 224 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 226 "../src/game-window.vala"
	self->priv->game_finished = TRUE;
#line 227 "../src/game-window.vala"
	_tmp0_ = self->priv->new_game_button;
#line 227 "../src/game-window.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp0_);
#line 912 "game-window.c"
}

void
game_window_allow_hint (GameWindow* self,
                        gboolean allow)
{
	gchar* stack_child = NULL;
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	GSimpleAction* _tmp6_;
#line 235 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 237 "../src/game-window.vala"
	_tmp0_ = self->priv->stack;
#line 237 "../src/game-window.vala"
	_tmp1_ = gtk_stack_get_visible_child_name (_tmp0_);
#line 237 "../src/game-window.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 237 "../src/game-window.vala"
	stack_child = _tmp2_;
#line 238 "../src/game-window.vala"
	_tmp4_ = stack_child;
#line 238 "../src/game-window.vala"
	if (_tmp4_ == NULL) {
#line 238 "../src/game-window.vala"
		_tmp3_ = TRUE;
#line 942 "game-window.c"
	} else {
		const gchar* _tmp5_;
#line 238 "../src/game-window.vala"
		_tmp5_ = stack_child;
#line 238 "../src/game-window.vala"
		_tmp3_ = g_strcmp0 ((const gchar*) _tmp5_, "game-box") != 0;
#line 949 "game-window.c"
	}
#line 238 "../src/game-window.vala"
	if (_tmp3_) {
#line 239 "../src/game-window.vala"
		_g_free0 (stack_child);
#line 239 "../src/game-window.vala"
		return;
#line 957 "game-window.c"
	}
#line 240 "../src/game-window.vala"
	_tmp6_ = self->priv->hint_action;
#line 240 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp6_, allow);
#line 235 "../src/game-window.vala"
	_g_free0 (stack_child);
#line 965 "game-window.c"
}

void
game_window_allow_undo (GameWindow* self,
                        gboolean allow)
{
	gchar* stack_child = NULL;
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	GSimpleAction* _tmp6_;
#line 243 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 245 "../src/game-window.vala"
	_tmp0_ = self->priv->stack;
#line 245 "../src/game-window.vala"
	_tmp1_ = gtk_stack_get_visible_child_name (_tmp0_);
#line 245 "../src/game-window.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 245 "../src/game-window.vala"
	stack_child = _tmp2_;
#line 246 "../src/game-window.vala"
	_tmp4_ = stack_child;
#line 246 "../src/game-window.vala"
	if (_tmp4_ == NULL) {
#line 246 "../src/game-window.vala"
		_tmp3_ = TRUE;
#line 995 "game-window.c"
	} else {
		const gchar* _tmp5_;
#line 246 "../src/game-window.vala"
		_tmp5_ = stack_child;
#line 246 "../src/game-window.vala"
		_tmp3_ = g_strcmp0 ((const gchar*) _tmp5_, "game-box") != 0;
#line 1002 "game-window.c"
	}
#line 246 "../src/game-window.vala"
	if (_tmp3_) {
#line 247 "../src/game-window.vala"
		_g_free0 (stack_child);
#line 247 "../src/game-window.vala"
		return;
#line 1010 "game-window.c"
	}
#line 248 "../src/game-window.vala"
	_tmp6_ = self->priv->undo_action;
#line 248 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp6_, allow);
#line 243 "../src/game-window.vala"
	_g_free0 (stack_child);
#line 1018 "game-window.c"
}

static void
game_window_real_set_window_size (AdaptativeWidget* base,
                                  AdaptativeWidgetWindowSize new_size)
{
	GameWindow * self;
	gboolean _is_extra_thin = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 257 "../src/game-window.vala"
	self = (GameWindow*) base;
#line 259 "../src/game-window.vala"
	self->priv->is_quite_thin = adaptative_widget_window_size_is_quite_thin (new_size);
#line 261 "../src/game-window.vala"
	_is_extra_thin = adaptative_widget_window_size_is_extra_thin (new_size);
#line 262 "../src/game-window.vala"
	_tmp0_ = self->priv->_is_extra_thin;
#line 262 "../src/game-window.vala"
	if (_is_extra_thin == _tmp0_) {
#line 263 "../src/game-window.vala"
		return;
#line 1041 "game-window.c"
	}
#line 264 "../src/game-window.vala"
	game_window_set_is_extra_thin (self, _is_extra_thin);
#line 266 "../src/game-window.vala"
	_tmp1_ = self->priv->_is_extra_thin;
#line 266 "../src/game-window.vala"
	if (_tmp1_) {
#line 1049 "game-window.c"
		GtkHeaderBar* _tmp2_;
		GtkWidget* _tmp3_;
#line 268 "../src/game-window.vala"
		_tmp2_ = self->priv->headerbar;
#line 268 "../src/game-window.vala"
		gtk_header_bar_set_title (_tmp2_, NULL);
#line 269 "../src/game-window.vala"
		_tmp3_ = self->priv->game_widget_1;
#line 269 "../src/game-window.vala"
		if (_tmp3_ != NULL) {
#line 1060 "game-window.c"
			GtkWidget* _tmp4_;
#line 270 "../src/game-window.vala"
			_tmp4_ = self->priv->game_widget_1;
#line 270 "../src/game-window.vala"
			gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget));
#line 1066 "game-window.c"
		}
	} else {
		gboolean _tmp5_ = FALSE;
		GtkWidget* _tmp6_;
		gchar* panel_name = NULL;
		GtkStack* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gboolean _tmp13_ = FALSE;
		const gchar* _tmp14_;
#line 274 "../src/game-window.vala"
		_tmp6_ = self->priv->game_widget_1;
#line 274 "../src/game-window.vala"
		if (_tmp6_ != NULL) {
#line 1081 "game-window.c"
			GtkStack* _tmp7_;
			const gchar* _tmp8_;
#line 274 "../src/game-window.vala"
			_tmp7_ = self->priv->stack;
#line 274 "../src/game-window.vala"
			_tmp8_ = gtk_stack_get_visible_child_name (_tmp7_);
#line 274 "../src/game-window.vala"
			_tmp5_ = g_strcmp0 ((const gchar*) _tmp8_, "game-box") == 0;
#line 1090 "game-window.c"
		} else {
#line 274 "../src/game-window.vala"
			_tmp5_ = FALSE;
#line 1094 "game-window.c"
		}
#line 274 "../src/game-window.vala"
		if (_tmp5_) {
#line 1098 "game-window.c"
			GtkWidget* _tmp9_;
#line 275 "../src/game-window.vala"
			_tmp9_ = self->priv->game_widget_1;
#line 275 "../src/game-window.vala"
			gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_widget_get_type (), GtkWidget));
#line 1104 "game-window.c"
		}
#line 276 "../src/game-window.vala"
		_tmp10_ = self->priv->stack;
#line 276 "../src/game-window.vala"
		_tmp11_ = gtk_stack_get_visible_child_name (_tmp10_);
#line 276 "../src/game-window.vala"
		_tmp12_ = g_strdup (_tmp11_);
#line 276 "../src/game-window.vala"
		panel_name = _tmp12_;
#line 277 "../src/game-window.vala"
		_tmp14_ = panel_name;
#line 277 "../src/game-window.vala"
		if (_tmp14_ != NULL) {
#line 1118 "game-window.c"
			const gchar* _tmp15_;
#line 277 "../src/game-window.vala"
			_tmp15_ = panel_name;
#line 277 "../src/game-window.vala"
			_tmp13_ = g_strcmp0 ((const gchar*) _tmp15_, "start-box") == 0;
#line 1124 "game-window.c"
		} else {
#line 277 "../src/game-window.vala"
			_tmp13_ = FALSE;
#line 1128 "game-window.c"
		}
#line 277 "../src/game-window.vala"
		if (_tmp13_) {
#line 1132 "game-window.c"
			GtkHeaderBar* _tmp16_;
			const gchar* _tmp17_;
#line 278 "../src/game-window.vala"
			_tmp16_ = self->priv->headerbar;
#line 278 "../src/game-window.vala"
			_tmp17_ = self->priv->program_name;
#line 278 "../src/game-window.vala"
			gtk_header_bar_set_title (_tmp16_, _tmp17_);
#line 1141 "game-window.c"
		} else {
			GtkHeaderBar* _tmp18_;
			const gchar* _tmp19_;
#line 280 "../src/game-window.vala"
			_tmp18_ = self->priv->headerbar;
#line 280 "../src/game-window.vala"
			_tmp19_ = self->priv->last_subtitle;
#line 280 "../src/game-window.vala"
			gtk_header_bar_set_title (_tmp18_, _tmp19_);
#line 1151 "game-window.c"
		}
#line 266 "../src/game-window.vala"
		_g_free0 (panel_name);
#line 1155 "game-window.c"
	}
}

static void
game_window_show_new_game_screen (GameWindow* self)
{
	gboolean _tmp0_;
	GameActionBar* _tmp3_;
	GtkStack* _tmp4_;
	GtkWidget* _tmp5_;
	GtkButton* _tmp7_;
	gboolean _tmp8_ = FALSE;
#line 289 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 291 "../src/game-window.vala"
	_tmp0_ = self->priv->_is_extra_thin;
#line 291 "../src/game-window.vala"
	if (!_tmp0_) {
#line 1174 "game-window.c"
		GtkHeaderBar* _tmp1_;
		const gchar* _tmp2_;
#line 292 "../src/game-window.vala"
		_tmp1_ = self->priv->headerbar;
#line 292 "../src/game-window.vala"
		_tmp2_ = self->priv->program_name;
#line 292 "../src/game-window.vala"
		gtk_header_bar_set_title (_tmp1_, _tmp2_);
#line 1183 "game-window.c"
	}
#line 293 "../src/game-window.vala"
	_tmp3_ = self->priv->actionbar;
#line 293 "../src/game-window.vala"
	game_action_bar_set_visibility (_tmp3_, FALSE);
#line 295 "../src/game-window.vala"
	_tmp4_ = self->priv->stack;
#line 295 "../src/game-window.vala"
	gtk_stack_set_visible_child_name (_tmp4_, "start-box");
#line 296 "../src/game-window.vala"
	_tmp5_ = self->priv->game_widget_1;
#line 296 "../src/game-window.vala"
	if (_tmp5_ != NULL) {
#line 1197 "game-window.c"
		GtkWidget* _tmp6_;
#line 297 "../src/game-window.vala"
		_tmp6_ = self->priv->game_widget_1;
#line 297 "../src/game-window.vala"
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget));
#line 1203 "game-window.c"
	}
#line 298 "../src/game-window.vala"
	_tmp7_ = self->priv->new_game_button;
#line 298 "../src/game-window.vala"
	gtk_widget_hide ((GtkWidget*) _tmp7_);
#line 300 "../src/game-window.vala"
	if (!self->priv->game_finished) {
#line 1211 "game-window.c"
		GtkButton* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
#line 300 "../src/game-window.vala"
		_tmp9_ = self->priv->back_button;
#line 300 "../src/game-window.vala"
		_tmp10_ = gtk_widget_get_visible ((GtkWidget*) _tmp9_);
#line 300 "../src/game-window.vala"
		_tmp11_ = _tmp10_;
#line 300 "../src/game-window.vala"
		_tmp8_ = _tmp11_;
#line 1223 "game-window.c"
	} else {
#line 300 "../src/game-window.vala"
		_tmp8_ = FALSE;
#line 1227 "game-window.c"
	}
#line 300 "../src/game-window.vala"
	if (_tmp8_) {
#line 1231 "game-window.c"
		GtkButton* _tmp12_;
#line 301 "../src/game-window.vala"
		_tmp12_ = self->priv->back_button;
#line 301 "../src/game-window.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp12_);
#line 1237 "game-window.c"
	} else {
		GtkButton* _tmp13_;
#line 302 "../src/game-window.vala"
		_tmp13_ = self->priv->start_game_button;
#line 302 "../src/game-window.vala"
		if (_tmp13_ != NULL) {
#line 1244 "game-window.c"
			GtkButton* _tmp14_;
#line 303 "../src/game-window.vala"
			_tmp14_ = self->priv->start_game_button;
#line 303 "../src/game-window.vala"
			gtk_widget_grab_focus ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_button_get_type (), GtkButton));
#line 1250 "game-window.c"
		}
	}
}

static void
game_window_show_view (GameWindow* self)
{
	gboolean _tmp0_;
	GameActionBar* _tmp3_;
	GtkStack* _tmp4_;
	GtkButton* _tmp5_;
	gboolean _tmp6_ = FALSE;
	GtkWidget* _tmp7_;
	GtkButton* _tmp10_;
#line 306 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 308 "../src/game-window.vala"
	_tmp0_ = self->priv->_is_extra_thin;
#line 308 "../src/game-window.vala"
	if (!_tmp0_) {
#line 1271 "game-window.c"
		GtkHeaderBar* _tmp1_;
		const gchar* _tmp2_;
#line 309 "../src/game-window.vala"
		_tmp1_ = self->priv->headerbar;
#line 309 "../src/game-window.vala"
		_tmp2_ = self->priv->last_subtitle;
#line 309 "../src/game-window.vala"
		gtk_header_bar_set_title (_tmp1_, _tmp2_);
#line 1280 "game-window.c"
	}
#line 310 "../src/game-window.vala"
	_tmp3_ = self->priv->actionbar;
#line 310 "../src/game-window.vala"
	game_action_bar_set_visibility (_tmp3_, TRUE);
#line 312 "../src/game-window.vala"
	_tmp4_ = self->priv->stack;
#line 312 "../src/game-window.vala"
	gtk_stack_set_visible_child_name (_tmp4_, "game-box");
#line 313 "../src/game-window.vala"
	_tmp5_ = self->priv->back_button;
#line 313 "../src/game-window.vala"
	gtk_widget_hide ((GtkWidget*) _tmp5_);
#line 314 "../src/game-window.vala"
	_tmp7_ = self->priv->game_widget_1;
#line 314 "../src/game-window.vala"
	if (_tmp7_ != NULL) {
#line 1298 "game-window.c"
		gboolean _tmp8_;
#line 314 "../src/game-window.vala"
		_tmp8_ = self->priv->_is_extra_thin;
#line 314 "../src/game-window.vala"
		_tmp6_ = !_tmp8_;
#line 1304 "game-window.c"
	} else {
#line 314 "../src/game-window.vala"
		_tmp6_ = FALSE;
#line 1308 "game-window.c"
	}
#line 314 "../src/game-window.vala"
	if (_tmp6_) {
#line 1312 "game-window.c"
		GtkWidget* _tmp9_;
#line 315 "../src/game-window.vala"
		_tmp9_ = self->priv->game_widget_1;
#line 315 "../src/game-window.vala"
		gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_widget_get_type (), GtkWidget));
#line 1318 "game-window.c"
	}
#line 316 "../src/game-window.vala"
	_tmp10_ = self->priv->new_game_button;
#line 316 "../src/game-window.vala"
	gtk_widget_show ((GtkWidget*) _tmp10_);
#line 318 "../src/game-window.vala"
	if (self->priv->game_finished) {
#line 1326 "game-window.c"
		GtkButton* _tmp11_;
#line 319 "../src/game-window.vala"
		_tmp11_ = self->priv->new_game_button;
#line 319 "../src/game-window.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp11_);
#line 1332 "game-window.c"
	} else {
		GtkWidget* _tmp12_;
#line 321 "../src/game-window.vala"
		_tmp12_ = self->priv->view;
#line 321 "../src/game-window.vala"
		gtk_widget_grab_focus (_tmp12_);
#line 1339 "game-window.c"
	}
}

static void
game_window_new_game_cb (GameWindow* self)
{
	gchar* stack_child = NULL;
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	GtkStack* _tmp6_;
	GtkStack* _tmp7_;
	GtkButton* _tmp8_;
	GSimpleAction* _tmp9_;
#line 328 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 330 "../src/game-window.vala"
	_tmp0_ = self->priv->stack;
#line 330 "../src/game-window.vala"
	_tmp1_ = gtk_stack_get_visible_child_name (_tmp0_);
#line 330 "../src/game-window.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 330 "../src/game-window.vala"
	stack_child = _tmp2_;
#line 331 "../src/game-window.vala"
	_tmp4_ = stack_child;
#line 331 "../src/game-window.vala"
	if (_tmp4_ == NULL) {
#line 331 "../src/game-window.vala"
		_tmp3_ = TRUE;
#line 1372 "game-window.c"
	} else {
		const gchar* _tmp5_;
#line 331 "../src/game-window.vala"
		_tmp5_ = stack_child;
#line 331 "../src/game-window.vala"
		_tmp3_ = g_strcmp0 ((const gchar*) _tmp5_, "game-box") != 0;
#line 1379 "game-window.c"
	}
#line 331 "../src/game-window.vala"
	if (_tmp3_) {
#line 332 "../src/game-window.vala"
		_g_free0 (stack_child);
#line 332 "../src/game-window.vala"
		return;
#line 1387 "game-window.c"
	}
#line 334 "../src/game-window.vala"
	g_signal_emit (self, game_window_signals[GAME_WINDOW_WAIT_SIGNAL], 0);
#line 336 "../src/game-window.vala"
	_tmp6_ = self->priv->stack;
#line 336 "../src/game-window.vala"
	gtk_stack_set_transition_type (_tmp6_, GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT);
#line 337 "../src/game-window.vala"
	_tmp7_ = self->priv->stack;
#line 337 "../src/game-window.vala"
	gtk_stack_set_transition_duration (_tmp7_, (guint) 800);
#line 339 "../src/game-window.vala"
	_tmp8_ = self->priv->back_button;
#line 339 "../src/game-window.vala"
	gtk_widget_show ((GtkWidget*) _tmp8_);
#line 340 "../src/game-window.vala"
	_tmp9_ = self->priv->back_action;
#line 340 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp9_, TRUE);
#line 342 "../src/game-window.vala"
	game_window_show_new_game_screen (self);
#line 328 "../src/game-window.vala"
	_g_free0 (stack_child);
#line 1411 "game-window.c"
}

static void
game_window_start_game_cb (GameWindow* self)
{
	gchar* stack_child = NULL;
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	GSimpleAction* _tmp6_;
	GSimpleAction* _tmp7_;
	GtkStack* _tmp10_;
#line 345 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 347 "../src/game-window.vala"
	_tmp0_ = self->priv->stack;
#line 347 "../src/game-window.vala"
	_tmp1_ = gtk_stack_get_visible_child_name (_tmp0_);
#line 347 "../src/game-window.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 347 "../src/game-window.vala"
	stack_child = _tmp2_;
#line 348 "../src/game-window.vala"
	_tmp4_ = stack_child;
#line 348 "../src/game-window.vala"
	if (_tmp4_ == NULL) {
#line 348 "../src/game-window.vala"
		_tmp3_ = TRUE;
#line 1442 "game-window.c"
	} else {
		const gchar* _tmp5_;
#line 348 "../src/game-window.vala"
		_tmp5_ = stack_child;
#line 348 "../src/game-window.vala"
		_tmp3_ = g_strcmp0 ((const gchar*) _tmp5_, "start-box") != 0;
#line 1449 "game-window.c"
	}
#line 348 "../src/game-window.vala"
	if (_tmp3_) {
#line 349 "../src/game-window.vala"
		_g_free0 (stack_child);
#line 349 "../src/game-window.vala"
		return;
#line 1457 "game-window.c"
	}
#line 351 "../src/game-window.vala"
	_g_free0 (self->priv->last_subtitle);
#line 351 "../src/game-window.vala"
	self->priv->last_subtitle = NULL;
#line 352 "../src/game-window.vala"
	self->priv->game_finished = FALSE;
#line 354 "../src/game-window.vala"
	_tmp6_ = self->priv->undo_action;
#line 354 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp6_, FALSE);
#line 356 "../src/game-window.vala"
	_tmp7_ = self->priv->hint_action;
#line 356 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp7_, TRUE);
#line 358 "../src/game-window.vala"
	g_signal_emit (self, game_window_signals[GAME_WINDOW_PLAY_SIGNAL], 0);
#line 360 "../src/game-window.vala"
	if (self->priv->is_quite_thin) {
#line 1477 "game-window.c"
		GtkStack* _tmp8_;
#line 361 "../src/game-window.vala"
		_tmp8_ = self->priv->stack;
#line 361 "../src/game-window.vala"
		gtk_stack_set_transition_type (_tmp8_, GTK_STACK_TRANSITION_TYPE_SLIDE_DOWN);
#line 1483 "game-window.c"
	} else {
		GtkStack* _tmp9_;
#line 363 "../src/game-window.vala"
		_tmp9_ = self->priv->stack;
#line 363 "../src/game-window.vala"
		gtk_stack_set_transition_type (_tmp9_, GTK_STACK_TRANSITION_TYPE_OVER_DOWN_UP);
#line 1490 "game-window.c"
	}
#line 364 "../src/game-window.vala"
	_tmp10_ = self->priv->stack;
#line 364 "../src/game-window.vala"
	gtk_stack_set_transition_duration (_tmp10_, (guint) 1000);
#line 365 "../src/game-window.vala"
	game_window_show_view (self);
#line 345 "../src/game-window.vala"
	_g_free0 (stack_child);
#line 1500 "game-window.c"
}

static void
game_window_back_cb (GameWindow* self)
{
	gchar* stack_child = NULL;
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	GtkStack* _tmp6_;
	GtkStack* _tmp7_;
#line 368 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 370 "../src/game-window.vala"
	_tmp0_ = self->priv->stack;
#line 370 "../src/game-window.vala"
	_tmp1_ = gtk_stack_get_visible_child_name (_tmp0_);
#line 370 "../src/game-window.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 370 "../src/game-window.vala"
	stack_child = _tmp2_;
#line 371 "../src/game-window.vala"
	_tmp4_ = stack_child;
#line 371 "../src/game-window.vala"
	if (_tmp4_ == NULL) {
#line 371 "../src/game-window.vala"
		_tmp3_ = TRUE;
#line 1530 "game-window.c"
	} else {
		const gchar* _tmp5_;
#line 371 "../src/game-window.vala"
		_tmp5_ = stack_child;
#line 371 "../src/game-window.vala"
		_tmp3_ = g_strcmp0 ((const gchar*) _tmp5_, "start-box") != 0;
#line 1537 "game-window.c"
	}
#line 371 "../src/game-window.vala"
	if (_tmp3_) {
#line 372 "../src/game-window.vala"
		_g_free0 (stack_child);
#line 372 "../src/game-window.vala"
		return;
#line 1545 "game-window.c"
	}
#line 374 "../src/game-window.vala"
	_tmp6_ = self->priv->stack;
#line 374 "../src/game-window.vala"
	gtk_stack_set_transition_type (_tmp6_, GTK_STACK_TRANSITION_TYPE_SLIDE_RIGHT);
#line 375 "../src/game-window.vala"
	_tmp7_ = self->priv->stack;
#line 375 "../src/game-window.vala"
	gtk_stack_set_transition_duration (_tmp7_, (guint) 800);
#line 376 "../src/game-window.vala"
	game_window_show_view (self);
#line 378 "../src/game-window.vala"
	g_signal_emit (self, game_window_signals[GAME_WINDOW_BACK_SIGNAL], 0);
#line 368 "../src/game-window.vala"
	_g_free0 (stack_child);
#line 1561 "game-window.c"
}

gboolean
game_window_new_game_screen_visible (GameWindow* self)
{
	gchar* stack_child = NULL;
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean result;
#line 381 "../src/game-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 383 "../src/game-window.vala"
	_tmp0_ = self->priv->stack;
#line 383 "../src/game-window.vala"
	_tmp1_ = gtk_stack_get_visible_child_name (_tmp0_);
#line 383 "../src/game-window.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 383 "../src/game-window.vala"
	stack_child = _tmp2_;
#line 384 "../src/game-window.vala"
	if (stack_child == NULL) {
#line 385 "../src/game-window.vala"
		g_assert_not_reached ();
#line 1586 "game-window.c"
	}
#line 386 "../src/game-window.vala"
	if (g_strcmp0 ((const gchar*) stack_child, "game-box") == 0) {
#line 387 "../src/game-window.vala"
		result = FALSE;
#line 387 "../src/game-window.vala"
		_g_free0 (stack_child);
#line 387 "../src/game-window.vala"
		return result;
#line 1596 "game-window.c"
	} else {
#line 389 "../src/game-window.vala"
		result = TRUE;
#line 389 "../src/game-window.vala"
		_g_free0 (stack_child);
#line 389 "../src/game-window.vala"
		return result;
#line 1604 "game-window.c"
	}
}

static void
game_window_undo_cb (GameWindow* self)
{
	gchar* stack_child = NULL;
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GtkButton* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
#line 396 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 398 "../src/game-window.vala"
	_tmp0_ = self->priv->stack;
#line 398 "../src/game-window.vala"
	_tmp1_ = gtk_stack_get_visible_child_name (_tmp0_);
#line 398 "../src/game-window.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 398 "../src/game-window.vala"
	stack_child = _tmp2_;
#line 399 "../src/game-window.vala"
	_tmp3_ = stack_child;
#line 399 "../src/game-window.vala"
	if (_tmp3_ == NULL) {
#line 400 "../src/game-window.vala"
		_g_free0 (stack_child);
#line 400 "../src/game-window.vala"
		return;
#line 1638 "game-window.c"
	}
#line 401 "../src/game-window.vala"
	_tmp4_ = stack_child;
#line 401 "../src/game-window.vala"
	if (g_strcmp0 ((const gchar*) _tmp4_, "game-box") != 0) {
#line 1644 "game-window.c"
		GSimpleAction* _tmp5_;
#line 403 "../src/game-window.vala"
		_tmp5_ = self->priv->back_action;
#line 403 "../src/game-window.vala"
		if (g_action_get_enabled ((GAction*) _tmp5_)) {
#line 404 "../src/game-window.vala"
			game_window_back_cb (self);
#line 1652 "game-window.c"
		}
#line 405 "../src/game-window.vala"
		_g_free0 (stack_child);
#line 405 "../src/game-window.vala"
		return;
#line 1658 "game-window.c"
	}
#line 408 "../src/game-window.vala"
	self->priv->game_finished = FALSE;
#line 410 "../src/game-window.vala"
	_tmp6_ = self->priv->back_button;
#line 410 "../src/game-window.vala"
	g_object_get ((GtkWidget*) _tmp6_, "is-focus", &_tmp7_, NULL);
#line 410 "../src/game-window.vala"
	_tmp8_ = _tmp7_;
#line 410 "../src/game-window.vala"
	if (!_tmp8_) {
#line 1670 "game-window.c"
		GtkWidget* _tmp9_;
#line 411 "../src/game-window.vala"
		_tmp9_ = self->priv->view;
#line 411 "../src/game-window.vala"
		gtk_widget_grab_focus (_tmp9_);
#line 1676 "game-window.c"
	}
#line 413 "../src/game-window.vala"
	g_signal_emit (self, game_window_signals[GAME_WINDOW_UNDO_SIGNAL], 0);
#line 396 "../src/game-window.vala"
	_g_free0 (stack_child);
#line 1682 "game-window.c"
}

static void
game_window_hint_cb (GameWindow* self)
{
	gchar* stack_child = NULL;
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
#line 428 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 430 "../src/game-window.vala"
	_tmp0_ = self->priv->stack;
#line 430 "../src/game-window.vala"
	_tmp1_ = gtk_stack_get_visible_child_name (_tmp0_);
#line 430 "../src/game-window.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 430 "../src/game-window.vala"
	stack_child = _tmp2_;
#line 431 "../src/game-window.vala"
	_tmp4_ = stack_child;
#line 431 "../src/game-window.vala"
	if (_tmp4_ == NULL) {
#line 431 "../src/game-window.vala"
		_tmp3_ = TRUE;
#line 1710 "game-window.c"
	} else {
		const gchar* _tmp5_;
#line 431 "../src/game-window.vala"
		_tmp5_ = stack_child;
#line 431 "../src/game-window.vala"
		_tmp3_ = g_strcmp0 ((const gchar*) _tmp5_, "game-box") != 0;
#line 1717 "game-window.c"
	}
#line 431 "../src/game-window.vala"
	if (_tmp3_) {
#line 432 "../src/game-window.vala"
		_g_free0 (stack_child);
#line 432 "../src/game-window.vala"
		return;
#line 1725 "game-window.c"
	}
#line 433 "../src/game-window.vala"
	g_signal_emit (self, game_window_signals[GAME_WINDOW_HINT_SIGNAL], 0);
#line 428 "../src/game-window.vala"
	_g_free0 (stack_child);
#line 1731 "game-window.c"
}

static inline void
game_window_toggle_hamburger (GameWindow* self)
{
	GtkMenuButton* _tmp0_;
	GtkMenuButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 442 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 444 "../src/game-window.vala"
	_tmp0_ = self->priv->info_button;
#line 444 "../src/game-window.vala"
	_tmp1_ = self->priv->info_button;
#line 444 "../src/game-window.vala"
	_tmp2_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp1_);
#line 444 "../src/game-window.vala"
	_tmp3_ = _tmp2_;
#line 444 "../src/game-window.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, !_tmp3_);
#line 1753 "game-window.c"
}

inline void
game_window_close_hamburger (GameWindow* self)
{
	GtkMenuButton* _tmp0_;
#line 447 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 449 "../src/game-window.vala"
	_tmp0_ = self->priv->info_button;
#line 449 "../src/game-window.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, FALSE);
#line 1766 "game-window.c"
}

gboolean
game_window_get_is_extra_thin (GameWindow* self)
{
	gboolean result;
#line 255 "../src/game-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 255 "../src/game-window.vala"
	result = self->priv->_is_extra_thin;
#line 255 "../src/game-window.vala"
	return result;
#line 1779 "game-window.c"
}

static void
game_window_set_is_extra_thin (GameWindow* self,
                               gboolean value)
{
	gboolean old_value;
#line 255 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 255 "../src/game-window.vala"
	old_value = game_window_get_is_extra_thin (self);
#line 255 "../src/game-window.vala"
	if (old_value != value) {
#line 255 "../src/game-window.vala"
		self->priv->_is_extra_thin = value;
#line 255 "../src/game-window.vala"
		g_object_notify_by_pspec ((GObject *) self, game_window_properties[GAME_WINDOW_IS_EXTRA_THIN_PROPERTY]);
#line 1797 "game-window.c"
	}
}

static void
game_window_class_init (GameWindowClass * klass,
                        gpointer klass_data)
{
#line 32 "../src/game-window.vala"
	game_window_parent_class = g_type_class_peek_parent (klass);
#line 32 "../src/game-window.vala"
	g_type_class_adjust_private_offset (klass, &GameWindow_private_offset);
#line 32 "../src/game-window.vala"
	((AdaptativeWindowClass *) klass)->on_fullscreen = (void (*) (AdaptativeWindow*)) game_window_real_on_fullscreen;
#line 32 "../src/game-window.vala"
	((AdaptativeWindowClass *) klass)->on_unfullscreen = (void (*) (AdaptativeWindow*)) game_window_real_on_unfullscreen;
#line 32 "../src/game-window.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_window_get_property;
#line 32 "../src/game-window.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_game_window_set_property;
#line 32 "../src/game-window.vala"
	G_OBJECT_CLASS (klass)->finalize = game_window_finalize;
#line 32 "../src/game-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_WINDOW_IS_EXTRA_THIN_PROPERTY, game_window_properties[GAME_WINDOW_IS_EXTRA_THIN_PROPERTY] = g_param_spec_boolean ("is-extra-thin", "is-extra-thin", "is-extra-thin", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../src/game-window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Four-in-a-row/ui/game-window.ui");
#line 32 "../src/game-window.vala"
	game_window_signals[GAME_WINDOW_PLAY_SIGNAL] = g_signal_new ("play", TYPE_GAME_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 32 "../src/game-window.vala"
	game_window_signals[GAME_WINDOW_WAIT_SIGNAL] = g_signal_new ("wait", TYPE_GAME_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 32 "../src/game-window.vala"
	game_window_signals[GAME_WINDOW_BACK_SIGNAL] = g_signal_new ("back", TYPE_GAME_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 32 "../src/game-window.vala"
	game_window_signals[GAME_WINDOW_UNDO_SIGNAL] = g_signal_new ("undo", TYPE_GAME_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 32 "../src/game-window.vala"
	game_window_signals[GAME_WINDOW_HINT_SIGNAL] = g_signal_new ("hint", TYPE_GAME_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 32 "../src/game-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "headerbar", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, headerbar));
#line 32 "../src/game-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "overlay", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, overlay));
#line 32 "../src/game-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "stack", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, stack));
#line 32 "../src/game-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "new_game_button", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, new_game_button));
#line 32 "../src/game-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "back_button", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, back_button));
#line 32 "../src/game-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "unfullscreen_button", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, unfullscreen_button));
#line 32 "../src/game-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "game_box", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, game_box));
#line 32 "../src/game-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "new_game_box", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, new_game_box));
#line 32 "../src/game-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "info_button", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, info_button));
#line 1851 "game-window.c"
}

static void
game_window_adaptative_widget_interface_init (AdaptativeWidgetIface * iface,
                                              gpointer iface_data)
{
#line 32 "../src/game-window.vala"
	game_window_adaptative_widget_parent_iface = g_type_interface_peek_parent (iface);
#line 32 "../src/game-window.vala"
	iface->set_window_size = (void (*) (AdaptativeWidget*, AdaptativeWidgetWindowSize)) game_window_real_set_window_size;
#line 1862 "game-window.c"
}

static void
game_window_instance_init (GameWindow * self,
                           gpointer klass)
{
	gchar* _tmp0_;
#line 32 "../src/game-window.vala"
	self->priv = game_window_get_instance_private (self);
#line 34 "../src/game-window.vala"
	self->priv->game_finished = FALSE;
#line 36 "../src/game-window.vala"
	_tmp0_ = g_strdup ("");
#line 36 "../src/game-window.vala"
	self->priv->program_name = _tmp0_;
#line 43 "../src/game-window.vala"
	self->priv->start_game_button = NULL;
#line 255 "../src/game-window.vala"
	self->priv->_is_extra_thin = FALSE;
#line 256 "../src/game-window.vala"
	self->priv->is_quite_thin = FALSE;
#line 288 "../src/game-window.vala"
	self->priv->last_subtitle = NULL;
#line 32 "../src/game-window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1888 "game-window.c"
}

static void
game_window_finalize (GObject * obj)
{
	GameWindow * self;
#line 32 "../src/game-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_WINDOW, GameWindow);
#line 36 "../src/game-window.vala"
	_g_free0 (self->priv->program_name);
#line 43 "../src/game-window.vala"
	_g_object_unref0 (self->priv->start_game_button);
#line 51 "../src/game-window.vala"
	_g_object_unref0 (self->priv->view);
#line 52 "../src/game-window.vala"
	_g_object_unref0 (self->priv->game_widget_1);
#line 53 "../src/game-window.vala"
	_g_object_unref0 (self->priv->actionbar);
#line 144 "../src/game-window.vala"
	_g_object_unref0 (self->priv->back_action);
#line 145 "../src/game-window.vala"
	_g_object_unref0 (self->priv->undo_action);
#line 147 "../src/game-window.vala"
	_g_object_unref0 (self->priv->hint_action);
#line 288 "../src/game-window.vala"
	_g_free0 (self->priv->last_subtitle);
#line 32 "../src/game-window.vala"
	G_OBJECT_CLASS (game_window_parent_class)->finalize (obj);
#line 1917 "game-window.c"
}

static GType
game_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GameWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameWindow), 0, (GInstanceInitFunc) game_window_instance_init, NULL };
	static const GInterfaceInfo adaptative_widget_info = { (GInterfaceInitFunc) game_window_adaptative_widget_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType game_window_type_id;
	game_window_type_id = g_type_register_static (TYPE_ADAPTATIVE_WINDOW, "GameWindow", &g_define_type_info, 0);
	g_type_add_interface_static (game_window_type_id, TYPE_ADAPTATIVE_WIDGET, &adaptative_widget_info);
	GameWindow_private_offset = g_type_add_instance_private (game_window_type_id, sizeof (GameWindowPrivate));
	return game_window_type_id;
}

GType
game_window_get_type (void)
{
	static volatile gsize game_window_type_id__once = 0;
	if (g_once_init_enter (&game_window_type_id__once)) {
		GType game_window_type_id;
		game_window_type_id = game_window_get_type_once ();
		g_once_init_leave (&game_window_type_id__once, game_window_type_id);
	}
	return game_window_type_id__once;
}

static void
_vala_game_window_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	GameWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME_WINDOW, GameWindow);
#line 32 "../src/game-window.vala"
	switch (property_id) {
#line 32 "../src/game-window.vala"
		case GAME_WINDOW_IS_EXTRA_THIN_PROPERTY:
#line 32 "../src/game-window.vala"
		g_value_set_boolean (value, game_window_get_is_extra_thin (self));
#line 32 "../src/game-window.vala"
		break;
#line 1960 "game-window.c"
		default:
#line 32 "../src/game-window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "../src/game-window.vala"
		break;
#line 1966 "game-window.c"
	}
}

static void
_vala_game_window_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	GameWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME_WINDOW, GameWindow);
#line 32 "../src/game-window.vala"
	switch (property_id) {
#line 32 "../src/game-window.vala"
		case GAME_WINDOW_IS_EXTRA_THIN_PROPERTY:
#line 32 "../src/game-window.vala"
		game_window_set_is_extra_thin (self, g_value_get_boolean (value));
#line 32 "../src/game-window.vala"
		break;
#line 1986 "game-window.c"
		default:
#line 32 "../src/game-window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "../src/game-window.vala"
		break;
#line 1992 "game-window.c"
	}
}

