/* theme.c generated by valac 0.56.14, the Vala compiler
 * generated from theme.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Four-in-a-row.

   Copyright © 2018 Jacob Humphrey

   GNOME Four-in-a-row is free software: you can redistribute it and/or
   modify it under the terms of the GNU General Public License as published
   by the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Four-in-a-row is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with GNOME Four-in-a-row.  If not, see <https://www.gnu.org/licenses/>.
*/
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <glib-object.h>
#include <glib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_THEME_MANAGER (theme_manager_get_type ())
#define THEME_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME_MANAGER, ThemeManager))
#define THEME_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME_MANAGER, ThemeManagerClass))
#define IS_THEME_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME_MANAGER))
#define IS_THEME_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME_MANAGER))
#define THEME_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME_MANAGER, ThemeManagerClass))

typedef struct _ThemeManager ThemeManager;
typedef struct _ThemeManagerClass ThemeManagerClass;
typedef struct _ThemeManagerPrivate ThemeManagerPrivate;
enum  {
	THEME_MANAGER_0_PROPERTY,
	THEME_MANAGER_THEME_ID_PROPERTY,
	THEME_MANAGER_BOARD_SIZE_PROPERTY,
	THEME_MANAGER_PB_TILESET_RAW_PROPERTY,
	THEME_MANAGER_PB_BGROUND_RAW_PROPERTY,
	THEME_MANAGER_NUM_PROPERTIES
};
static GParamSpec* theme_manager_properties[THEME_MANAGER_NUM_PROPERTIES];

#define THEME_MANAGER_TYPE_THEME (theme_manager_theme_get_type ())
typedef struct _ThemeManagerTheme ThemeManagerTheme;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	PLAYER_NOBODY,
	PLAYER_HUMAN,
	PLAYER_OPPONENT
} Player;

#define TYPE_PLAYER (player_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	THEME_MANAGER_THEME_CHANGED_SIGNAL,
	THEME_MANAGER_NUM_SIGNALS
};
static guint theme_manager_signals[THEME_MANAGER_NUM_SIGNALS] = {0};

struct _ThemeManager {
	GObject parent_instance;
	ThemeManagerPrivate * priv;
};

struct _ThemeManagerClass {
	GObjectClass parent_class;
};

struct _ThemeManagerPrivate {
	gboolean theme_set;
	gint _theme_id;
	guint8 _board_size;
	gboolean pixmaps_loaded;
	GdkPixbuf* _pb_tileset_raw;
	GdkPixbuf* _pb_bground_raw;
};

struct _ThemeManagerTheme {
	gchar* title;
	gchar* fname_tileset;
	gchar* fname_bground;
	gchar* grid_color;
	gchar* player1;
	gchar* player2;
	gchar* player1_with_colon;
	gchar* player2_with_colon;
	gchar* player1_win;
	gchar* player2_win;
	gchar* player1_turn;
	gchar* player2_turn;
};

static gint ThemeManager_private_offset;
static gpointer theme_manager_parent_class = NULL;

VALA_EXTERN GType theme_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ThemeManager, g_object_unref)
static GType theme_manager_theme_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static ThemeManagerTheme* theme_manager_theme_dup (const ThemeManagerTheme* self);
static void theme_manager_theme_free (ThemeManagerTheme* self);
static void theme_manager_theme_copy (const ThemeManagerTheme* self,
                               ThemeManagerTheme* dest);
static void theme_manager_theme_destroy (ThemeManagerTheme* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (ThemeManagerTheme, theme_manager_theme_destroy)
VALA_EXTERN ThemeManager* theme_manager_new (guint8 size);
VALA_EXTERN ThemeManager* theme_manager_construct (GType object_type,
                                       guint8 size);
VALA_EXTERN GType player_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* theme_manager_get_player_turn (ThemeManager* self,
                                      Player who);
static gint theme_manager_get_theme_id (ThemeManager* self);
VALA_EXTERN gchar* theme_manager_get_player_win (ThemeManager* self,
                                     Player who);
VALA_EXTERN gchar* theme_manager_get_player (ThemeManager* self,
                                 Player who,
                                 gboolean with_colon);
VALA_EXTERN gchar* theme_manager_get_grid_color (ThemeManager* self);
static void theme_manager_load_pixmaps (ThemeManager* self);
static void theme_manager_load_image (const gchar* image_name,
                               GdkPixbuf** pixbuf);
static inline void theme_manager_create_background (ThemeManager* self);
static guint8 theme_manager_get_board_size (ThemeManager* self);
VALA_EXTERN gchar** theme_manager_get_themes (ThemeManager* self,
                                  gint* result_length1);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN void theme_manager_set_theme_id (ThemeManager* self,
                                 gint value);
static void theme_manager_set_board_size (ThemeManager* self,
                                   guint8 value);
VALA_EXTERN GdkPixbuf* theme_manager_get_pb_tileset_raw (ThemeManager* self);
VALA_EXTERN GdkPixbuf* theme_manager_get_pb_bground_raw (ThemeManager* self);
static void theme_manager_finalize (GObject * obj);
static GType theme_manager_get_type_once (void);
static void _vala_theme_manager_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_theme_manager_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);

static const ThemeManagerTheme THEME_MANAGER_theme[5] = {{N_ ("High Contrast"), "tileset_50x50_hcontrast.svg", NULL, "#000000", N_ ("Circle"), N_ ("Cross"), N_ ("Circle:"), N_ ("Cross:"), N_ ("Circle wins!"), N_ ("Cross wins!"), N_ ("Circle’s turn"), N_ ("Cross’s turn")}, {N_ ("High Contrast Inverse"), "tileset_50x50_hcinverse.svg", NULL, "#FFFFFF", N_ ("Circle"), N_ ("Cross"), N_ ("Circle:"), N_ ("Cross:"), N_ ("Circle wins!"), N_ ("Cross wins!"), N_ ("Circle’s turn"), N_ ("Cross’s turn")}, {N_ ("Red and Green Marbles"), "tileset_50x50_faenza-glines-icon1.svg", "bg_toplight.png", "#727F8C", N_ ("Red"), N_ ("Green"), N_ ("Red:"), N_ ("Green:"), N_ ("Red wins!"), N_ ("Green wins!"), N_ ("Red’s turn"), N_ ("Green’s turn")}, {N_ ("Blue and Red Marbles"), "tileset_50x50_faenza-glines-icon2.svg", "bg_toplight.png", "#727F8C", N_ ("Blue"), N_ ("Red"), N_ ("Blue:"), N_ ("Red:"), N_ ("Blue wins!"), N_ ("Red wins!"), N_ ("Blue’s turn"), N_ ("Red’s turn")}, {N_ ("Stars and Rings"), "tileset_50x50_faenza-gnect-icon.svg", "bg_toplight.png", "#727F8C", N_ ("Red"), N_ ("Green"), N_ ("Red:"), N_ ("Green:"), N_ ("Red wins!"), N_ ("Green wins!"), N_ ("Red’s turn"), N_ ("Green’s turn")}};

static inline gpointer
theme_manager_get_instance_private (ThemeManager* self)
{
	return G_STRUCT_MEMBER_P (self, ThemeManager_private_offset);
}

ThemeManager*
theme_manager_construct (GType object_type,
                         guint8 size)
{
	ThemeManager * self = NULL;
#line 36 "../src/theme.vala"
	self = (ThemeManager*) g_object_new (object_type, "board-size", size, NULL);
#line 34 "../src/theme.vala"
	return self;
#line 189 "theme.c"
}

ThemeManager*
theme_manager_new (guint8 size)
{
#line 34 "../src/theme.vala"
	return theme_manager_construct (TYPE_THEME_MANAGER, size);
#line 197 "theme.c"
}

gchar*
theme_manager_get_player_turn (ThemeManager* self,
                               Player who)
{
	gchar* result;
#line 43 "../src/theme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "../src/theme.vala"
	if (who == PLAYER_HUMAN) {
#line 209 "theme.c"
		gint _tmp0_;
		gint _tmp1_;
		ThemeManagerTheme _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 46 "../src/theme.vala"
		_tmp0_ = theme_manager_get_theme_id (self);
#line 46 "../src/theme.vala"
		_tmp1_ = _tmp0_;
#line 46 "../src/theme.vala"
		_tmp2_ = THEME_MANAGER_theme[_tmp1_];
#line 46 "../src/theme.vala"
		_tmp3_ = _tmp2_.player1_turn;
#line 46 "../src/theme.vala"
		_tmp4_ = g_strdup (_tmp3_);
#line 46 "../src/theme.vala"
		result = _tmp4_;
#line 46 "../src/theme.vala"
		return result;
#line 229 "theme.c"
	} else {
		gint _tmp5_;
		gint _tmp6_;
		ThemeManagerTheme _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 48 "../src/theme.vala"
		_tmp5_ = theme_manager_get_theme_id (self);
#line 48 "../src/theme.vala"
		_tmp6_ = _tmp5_;
#line 48 "../src/theme.vala"
		_tmp7_ = THEME_MANAGER_theme[_tmp6_];
#line 48 "../src/theme.vala"
		_tmp8_ = _tmp7_.player2_turn;
#line 48 "../src/theme.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 48 "../src/theme.vala"
		result = _tmp9_;
#line 48 "../src/theme.vala"
		return result;
#line 250 "theme.c"
	}
}

gchar*
theme_manager_get_player_win (ThemeManager* self,
                              Player who)
{
	gchar* result;
#line 51 "../src/theme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 53 "../src/theme.vala"
	if (who == PLAYER_HUMAN) {
#line 263 "theme.c"
		gint _tmp0_;
		gint _tmp1_;
		ThemeManagerTheme _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 54 "../src/theme.vala"
		_tmp0_ = theme_manager_get_theme_id (self);
#line 54 "../src/theme.vala"
		_tmp1_ = _tmp0_;
#line 54 "../src/theme.vala"
		_tmp2_ = THEME_MANAGER_theme[_tmp1_];
#line 54 "../src/theme.vala"
		_tmp3_ = _tmp2_.player1_win;
#line 54 "../src/theme.vala"
		_tmp4_ = g_strdup (_tmp3_);
#line 54 "../src/theme.vala"
		result = _tmp4_;
#line 54 "../src/theme.vala"
		return result;
#line 283 "theme.c"
	} else {
		gint _tmp5_;
		gint _tmp6_;
		ThemeManagerTheme _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 56 "../src/theme.vala"
		_tmp5_ = theme_manager_get_theme_id (self);
#line 56 "../src/theme.vala"
		_tmp6_ = _tmp5_;
#line 56 "../src/theme.vala"
		_tmp7_ = THEME_MANAGER_theme[_tmp6_];
#line 56 "../src/theme.vala"
		_tmp8_ = _tmp7_.player2_win;
#line 56 "../src/theme.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 56 "../src/theme.vala"
		result = _tmp9_;
#line 56 "../src/theme.vala"
		return result;
#line 304 "theme.c"
	}
}

gchar*
theme_manager_get_player (ThemeManager* self,
                          Player who,
                          gboolean with_colon)
{
	gchar* result;
#line 59 "../src/theme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 61 "../src/theme.vala"
	if (with_colon) {
#line 63 "../src/theme.vala"
		if (who == PLAYER_HUMAN) {
#line 320 "theme.c"
			gint _tmp0_;
			gint _tmp1_;
			ThemeManagerTheme _tmp2_;
			const gchar* _tmp3_;
			gchar* _tmp4_;
#line 64 "../src/theme.vala"
			_tmp0_ = theme_manager_get_theme_id (self);
#line 64 "../src/theme.vala"
			_tmp1_ = _tmp0_;
#line 64 "../src/theme.vala"
			_tmp2_ = THEME_MANAGER_theme[_tmp1_];
#line 64 "../src/theme.vala"
			_tmp3_ = _tmp2_.player1_with_colon;
#line 64 "../src/theme.vala"
			_tmp4_ = g_strdup (_ (_tmp3_));
#line 64 "../src/theme.vala"
			result = _tmp4_;
#line 64 "../src/theme.vala"
			return result;
#line 340 "theme.c"
		} else {
			gint _tmp5_;
			gint _tmp6_;
			ThemeManagerTheme _tmp7_;
			const gchar* _tmp8_;
			gchar* _tmp9_;
#line 66 "../src/theme.vala"
			_tmp5_ = theme_manager_get_theme_id (self);
#line 66 "../src/theme.vala"
			_tmp6_ = _tmp5_;
#line 66 "../src/theme.vala"
			_tmp7_ = THEME_MANAGER_theme[_tmp6_];
#line 66 "../src/theme.vala"
			_tmp8_ = _tmp7_.player2_with_colon;
#line 66 "../src/theme.vala"
			_tmp9_ = g_strdup (_ (_tmp8_));
#line 66 "../src/theme.vala"
			result = _tmp9_;
#line 66 "../src/theme.vala"
			return result;
#line 361 "theme.c"
		}
	} else {
#line 70 "../src/theme.vala"
		if (who == PLAYER_HUMAN) {
#line 366 "theme.c"
			gint _tmp10_;
			gint _tmp11_;
			ThemeManagerTheme _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
#line 71 "../src/theme.vala"
			_tmp10_ = theme_manager_get_theme_id (self);
#line 71 "../src/theme.vala"
			_tmp11_ = _tmp10_;
#line 71 "../src/theme.vala"
			_tmp12_ = THEME_MANAGER_theme[_tmp11_];
#line 71 "../src/theme.vala"
			_tmp13_ = _tmp12_.player1;
#line 71 "../src/theme.vala"
			_tmp14_ = g_strdup (_ (_tmp13_));
#line 71 "../src/theme.vala"
			result = _tmp14_;
#line 71 "../src/theme.vala"
			return result;
#line 386 "theme.c"
		} else {
			gint _tmp15_;
			gint _tmp16_;
			ThemeManagerTheme _tmp17_;
			const gchar* _tmp18_;
			gchar* _tmp19_;
#line 73 "../src/theme.vala"
			_tmp15_ = theme_manager_get_theme_id (self);
#line 73 "../src/theme.vala"
			_tmp16_ = _tmp15_;
#line 73 "../src/theme.vala"
			_tmp17_ = THEME_MANAGER_theme[_tmp16_];
#line 73 "../src/theme.vala"
			_tmp18_ = _tmp17_.player2;
#line 73 "../src/theme.vala"
			_tmp19_ = g_strdup (_ (_tmp18_));
#line 73 "../src/theme.vala"
			result = _tmp19_;
#line 73 "../src/theme.vala"
			return result;
#line 407 "theme.c"
		}
	}
}

gchar*
theme_manager_get_grid_color (ThemeManager* self)
{
	gint _tmp0_;
	gint _tmp1_;
	ThemeManagerTheme _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 77 "../src/theme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 79 "../src/theme.vala"
	_tmp0_ = theme_manager_get_theme_id (self);
#line 79 "../src/theme.vala"
	_tmp1_ = _tmp0_;
#line 79 "../src/theme.vala"
	_tmp2_ = THEME_MANAGER_theme[_tmp1_];
#line 79 "../src/theme.vala"
	_tmp3_ = _tmp2_.grid_color;
#line 79 "../src/theme.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 79 "../src/theme.vala"
	result = _tmp4_;
#line 79 "../src/theme.vala"
	return result;
#line 437 "theme.c"
}

static void
theme_manager_load_pixmaps (ThemeManager* self)
{
	gint _tmp0_;
	gint _tmp1_;
	ThemeManagerTheme _tmp2_;
	const gchar* _tmp3_;
	GdkPixbuf* _tmp4_ = NULL;
	gint _tmp5_;
	gint _tmp6_;
	ThemeManagerTheme _tmp7_;
	const gchar* _tmp8_;
#line 93 "../src/theme.vala"
	g_return_if_fail (self != NULL);
#line 95 "../src/theme.vala"
	_tmp0_ = theme_manager_get_theme_id (self);
#line 95 "../src/theme.vala"
	_tmp1_ = _tmp0_;
#line 95 "../src/theme.vala"
	_tmp2_ = THEME_MANAGER_theme[_tmp1_];
#line 95 "../src/theme.vala"
	_tmp3_ = _tmp2_.fname_tileset;
#line 95 "../src/theme.vala"
	theme_manager_load_image (_tmp3_, &_tmp4_);
#line 95 "../src/theme.vala"
	_g_object_unref0 (self->priv->_pb_tileset_raw);
#line 95 "../src/theme.vala"
	self->priv->_pb_tileset_raw = _tmp4_;
#line 97 "../src/theme.vala"
	_tmp5_ = theme_manager_get_theme_id (self);
#line 97 "../src/theme.vala"
	_tmp6_ = _tmp5_;
#line 97 "../src/theme.vala"
	_tmp7_ = THEME_MANAGER_theme[_tmp6_];
#line 97 "../src/theme.vala"
	_tmp8_ = _tmp7_.fname_bground;
#line 97 "../src/theme.vala"
	if (_tmp8_ != NULL) {
#line 478 "theme.c"
		gint _tmp9_;
		gint _tmp10_;
		ThemeManagerTheme _tmp11_;
		const gchar* _tmp12_;
		GdkPixbuf* _tmp13_ = NULL;
#line 98 "../src/theme.vala"
		_tmp9_ = theme_manager_get_theme_id (self);
#line 98 "../src/theme.vala"
		_tmp10_ = _tmp9_;
#line 98 "../src/theme.vala"
		_tmp11_ = THEME_MANAGER_theme[_tmp10_];
#line 98 "../src/theme.vala"
		_tmp12_ = _tmp11_.fname_bground;
#line 98 "../src/theme.vala"
		theme_manager_load_image ((const gchar*) _tmp12_, &_tmp13_);
#line 98 "../src/theme.vala"
		_g_object_unref0 (self->priv->_pb_bground_raw);
#line 98 "../src/theme.vala"
		self->priv->_pb_bground_raw = _tmp13_;
#line 498 "theme.c"
	} else {
#line 100 "../src/theme.vala"
		theme_manager_create_background (self);
#line 502 "theme.c"
	}
#line 102 "../src/theme.vala"
	self->priv->pixmaps_loaded = TRUE;
#line 506 "theme.c"
}

static void
theme_manager_load_image (const gchar* image_name,
                          GdkPixbuf** pixbuf)
{
	GdkPixbuf* _vala_pixbuf = NULL;
	gchar* image_resource = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 105 "../src/theme.vala"
	g_return_if_fail (image_name != NULL);
#line 107 "../src/theme.vala"
	_tmp0_ = g_strconcat ("/org/gnome/Four-in-a-row/images/", image_name, NULL);
#line 107 "../src/theme.vala"
	image_resource = _tmp0_;
#line 523 "theme.c"
	{
		GdkPixbuf* _tmp1_ = NULL;
		GdkPixbuf* _tmp2_;
		GdkPixbuf* _tmp3_;
#line 110 "../src/theme.vala"
		_tmp2_ = gdk_pixbuf_new_from_resource (image_resource, &_inner_error0_);
#line 110 "../src/theme.vala"
		_tmp1_ = _tmp2_;
#line 110 "../src/theme.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 534 "theme.c"
			goto __catch0_g_error;
		}
#line 110 "../src/theme.vala"
		_tmp3_ = _tmp1_;
#line 110 "../src/theme.vala"
		_tmp1_ = NULL;
#line 110 "../src/theme.vala"
		_g_object_unref0 (_vala_pixbuf);
#line 110 "../src/theme.vala"
		_vala_pixbuf = _tmp3_;
#line 108 "../src/theme.vala"
		_g_object_unref0 (_tmp1_);
#line 547 "theme.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp4_;
#line 108 "../src/theme.vala"
		e = _inner_error0_;
#line 108 "../src/theme.vala"
		_inner_error0_ = NULL;
#line 114 "../src/theme.vala"
		_tmp4_ = e->message;
#line 114 "../src/theme.vala"
		g_critical ("theme.vala:114: %s", _tmp4_);
#line 115 "../src/theme.vala"
		g_assert_not_reached ();
#line 108 "../src/theme.vala"
		_g_error_free0 (e);
#line 566 "theme.c"
	}
	__finally0:
#line 108 "../src/theme.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 108 "../src/theme.vala"
		_g_free0 (image_resource);
#line 108 "../src/theme.vala"
		_g_object_unref0 (_vala_pixbuf);
#line 108 "../src/theme.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 108 "../src/theme.vala"
		g_clear_error (&_inner_error0_);
#line 108 "../src/theme.vala"
		return;
#line 581 "theme.c"
	}
#line 105 "../src/theme.vala"
	_g_free0 (image_resource);
#line 105 "../src/theme.vala"
	if (pixbuf) {
#line 105 "../src/theme.vala"
		*pixbuf = _vala_pixbuf;
#line 589 "theme.c"
	} else {
#line 105 "../src/theme.vala"
		_g_object_unref0 (_vala_pixbuf);
#line 593 "theme.c"
	}
}

static inline void
theme_manager_create_background (ThemeManager* self)
{
	gint raw_tile_size = 0;
	GdkPixbuf* _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
	GdkPixbuf* _tmp3_;
#line 119 "../src/theme.vala"
	g_return_if_fail (self != NULL);
#line 121 "../src/theme.vala"
	_tmp0_ = self->priv->_pb_tileset_raw;
#line 121 "../src/theme.vala"
	raw_tile_size = gdk_pixbuf_get_height (_tmp0_);
#line 123 "../src/theme.vala"
	_tmp1_ = self->priv->_board_size;
#line 123 "../src/theme.vala"
	_tmp2_ = self->priv->_board_size;
#line 123 "../src/theme.vala"
	_tmp3_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, raw_tile_size * _tmp1_, raw_tile_size * _tmp2_);
#line 123 "../src/theme.vala"
	_g_object_unref0 (self->priv->_pb_bground_raw);
#line 123 "../src/theme.vala"
	self->priv->_pb_bground_raw = _tmp3_;
#line 621 "theme.c"
	{
		gint i = 0;
#line 124 "../src/theme.vala"
		i = 0;
#line 626 "theme.c"
		{
			gboolean _tmp4_ = FALSE;
#line 124 "../src/theme.vala"
			_tmp4_ = TRUE;
#line 124 "../src/theme.vala"
			while (TRUE) {
#line 633 "theme.c"
				guint8 _tmp6_;
				GdkPixbuf* _tmp7_;
				GdkPixbuf* _tmp8_;
#line 124 "../src/theme.vala"
				if (!_tmp4_) {
#line 639 "theme.c"
					gint _tmp5_;
#line 124 "../src/theme.vala"
					_tmp5_ = i;
#line 124 "../src/theme.vala"
					i = _tmp5_ + 1;
#line 645 "theme.c"
				}
#line 124 "../src/theme.vala"
				_tmp4_ = FALSE;
#line 124 "../src/theme.vala"
				_tmp6_ = self->priv->_board_size;
#line 124 "../src/theme.vala"
				if (!(i < ((gint) _tmp6_))) {
#line 124 "../src/theme.vala"
					break;
#line 655 "theme.c"
				}
#line 126 "../src/theme.vala"
				_tmp7_ = self->priv->_pb_tileset_raw;
#line 126 "../src/theme.vala"
				_tmp8_ = self->priv->_pb_bground_raw;
#line 126 "../src/theme.vala"
				gdk_pixbuf_copy_area (_tmp7_, raw_tile_size * 3, 0, raw_tile_size, raw_tile_size, _tmp8_, i * raw_tile_size, 0);
#line 663 "theme.c"
				{
					gint j = 0;
#line 131 "../src/theme.vala"
					j = 1;
#line 668 "theme.c"
					{
						gboolean _tmp9_ = FALSE;
#line 131 "../src/theme.vala"
						_tmp9_ = TRUE;
#line 131 "../src/theme.vala"
						while (TRUE) {
#line 675 "theme.c"
							guint8 _tmp11_;
							GdkPixbuf* _tmp12_;
							GdkPixbuf* _tmp13_;
#line 131 "../src/theme.vala"
							if (!_tmp9_) {
#line 681 "theme.c"
								gint _tmp10_;
#line 131 "../src/theme.vala"
								_tmp10_ = j;
#line 131 "../src/theme.vala"
								j = _tmp10_ + 1;
#line 687 "theme.c"
							}
#line 131 "../src/theme.vala"
							_tmp9_ = FALSE;
#line 131 "../src/theme.vala"
							_tmp11_ = self->priv->_board_size;
#line 131 "../src/theme.vala"
							if (!(j < ((gint) _tmp11_))) {
#line 131 "../src/theme.vala"
								break;
#line 697 "theme.c"
							}
#line 132 "../src/theme.vala"
							_tmp12_ = self->priv->_pb_tileset_raw;
#line 132 "../src/theme.vala"
							_tmp13_ = self->priv->_pb_bground_raw;
#line 132 "../src/theme.vala"
							gdk_pixbuf_copy_area (_tmp12_, raw_tile_size * 2, 0, raw_tile_size, raw_tile_size, _tmp13_, i * raw_tile_size, j * raw_tile_size);
#line 705 "theme.c"
						}
					}
				}
			}
		}
	}
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 147 "../src/theme.vala"
	if ((*length) == (*size)) {
#line 147 "../src/theme.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 147 "../src/theme.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 726 "theme.c"
	}
#line 147 "../src/theme.vala"
	(*array)[(*length)++] = value;
#line 147 "../src/theme.vala"
	(*array)[*length] = NULL;
#line 732 "theme.c"
}

gchar**
theme_manager_get_themes (ThemeManager* self,
                          gint* result_length1)
{
	gchar** themes = NULL;
	gchar** _tmp0_;
	gint themes_length1;
	gint _themes_size_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gchar** result;
#line 143 "../src/theme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 145 "../src/theme.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 145 "../src/theme.vala"
	themes = _tmp0_;
#line 145 "../src/theme.vala"
	themes_length1 = 0;
#line 145 "../src/theme.vala"
	_themes_size_ = themes_length1;
#line 756 "theme.c"
	{
		guint8 i = 0U;
#line 146 "../src/theme.vala"
		i = (guint8) 0;
#line 761 "theme.c"
		{
			gboolean _tmp1_ = FALSE;
#line 146 "../src/theme.vala"
			_tmp1_ = TRUE;
#line 146 "../src/theme.vala"
			while (TRUE) {
#line 768 "theme.c"
				ThemeManagerTheme _tmp3_;
				const gchar* _tmp4_;
				gchar* _tmp5_;
#line 146 "../src/theme.vala"
				if (!_tmp1_) {
#line 774 "theme.c"
					guint8 _tmp2_;
#line 146 "../src/theme.vala"
					_tmp2_ = i;
#line 146 "../src/theme.vala"
					i = _tmp2_ + 1;
#line 780 "theme.c"
				}
#line 146 "../src/theme.vala"
				_tmp1_ = FALSE;
#line 146 "../src/theme.vala"
				if (!(((gint) i) < G_N_ELEMENTS (THEME_MANAGER_theme))) {
#line 146 "../src/theme.vala"
					break;
#line 788 "theme.c"
				}
#line 147 "../src/theme.vala"
				_tmp3_ = THEME_MANAGER_theme[i];
#line 147 "../src/theme.vala"
				_tmp4_ = _tmp3_.title;
#line 147 "../src/theme.vala"
				_tmp5_ = g_strdup (_ (_tmp4_));
#line 147 "../src/theme.vala"
				_vala_array_add1 (&themes, &themes_length1, &_themes_size_, _tmp5_);
#line 798 "theme.c"
			}
		}
	}
#line 148 "../src/theme.vala"
	_tmp6_ = themes;
#line 148 "../src/theme.vala"
	_tmp6__length1 = themes_length1;
#line 148 "../src/theme.vala"
	if (result_length1) {
#line 148 "../src/theme.vala"
		*result_length1 = _tmp6__length1;
#line 810 "theme.c"
	}
#line 148 "../src/theme.vala"
	result = _tmp6_;
#line 148 "../src/theme.vala"
	return result;
#line 816 "theme.c"
}

static gint
theme_manager_get_theme_id (ThemeManager* self)
{
	gint result;
#line 28 "../src/theme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 28 "../src/theme.vala"
	if (!self->priv->theme_set) {
#line 28 "../src/theme.vala"
		g_assert_not_reached ();
#line 829 "theme.c"
	}
#line 28 "../src/theme.vala"
	result = self->priv->_theme_id;
#line 28 "../src/theme.vala"
	return result;
#line 835 "theme.c"
}

void
theme_manager_set_theme_id (ThemeManager* self,
                            gint value)
{
#line 29 "../src/theme.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/theme.vala"
	self->priv->_theme_id = value;
#line 29 "../src/theme.vala"
	self->priv->theme_set = TRUE;
#line 29 "../src/theme.vala"
	theme_manager_load_pixmaps (self);
#line 29 "../src/theme.vala"
	g_signal_emit (self, theme_manager_signals[THEME_MANAGER_THEME_CHANGED_SIGNAL], 0);
#line 852 "theme.c"
}

static guint8
theme_manager_get_board_size (ThemeManager* self)
{
	guint8 result;
#line 32 "../src/theme.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 32 "../src/theme.vala"
	result = self->priv->_board_size;
#line 32 "../src/theme.vala"
	return result;
#line 865 "theme.c"
}

static void
theme_manager_set_board_size (ThemeManager* self,
                              guint8 value)
{
#line 32 "../src/theme.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/theme.vala"
	self->priv->_board_size = value;
#line 876 "theme.c"
}

GdkPixbuf*
theme_manager_get_pb_tileset_raw (ThemeManager* self)
{
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_;
#line 87 "../src/theme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 87 "../src/theme.vala"
	if (!self->priv->pixmaps_loaded) {
#line 87 "../src/theme.vala"
		g_assert_not_reached ();
#line 890 "theme.c"
	}
#line 87 "../src/theme.vala"
	_tmp0_ = self->priv->_pb_tileset_raw;
#line 87 "../src/theme.vala"
	result = _tmp0_;
#line 87 "../src/theme.vala"
	return result;
#line 898 "theme.c"
}

GdkPixbuf*
theme_manager_get_pb_bground_raw (ThemeManager* self)
{
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_;
#line 88 "../src/theme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 88 "../src/theme.vala"
	if (!self->priv->pixmaps_loaded) {
#line 88 "../src/theme.vala"
		g_assert_not_reached ();
#line 912 "theme.c"
	}
#line 88 "../src/theme.vala"
	_tmp0_ = self->priv->_pb_bground_raw;
#line 88 "../src/theme.vala"
	result = _tmp0_;
#line 88 "../src/theme.vala"
	return result;
#line 920 "theme.c"
}

static void
theme_manager_theme_copy (const ThemeManagerTheme* self,
                          ThemeManagerTheme* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
#line 151 "../src/theme.vala"
	_tmp0_ = (*self).title;
#line 151 "../src/theme.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 151 "../src/theme.vala"
	_g_free0 ((*dest).title);
#line 151 "../src/theme.vala"
	(*dest).title = _tmp1_;
#line 151 "../src/theme.vala"
	_tmp2_ = (*self).fname_tileset;
#line 151 "../src/theme.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 151 "../src/theme.vala"
	_g_free0 ((*dest).fname_tileset);
#line 151 "../src/theme.vala"
	(*dest).fname_tileset = _tmp3_;
#line 151 "../src/theme.vala"
	_tmp4_ = (*self).fname_bground;
#line 151 "../src/theme.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 151 "../src/theme.vala"
	_g_free0 ((*dest).fname_bground);
#line 151 "../src/theme.vala"
	(*dest).fname_bground = _tmp5_;
#line 151 "../src/theme.vala"
	_tmp6_ = (*self).grid_color;
#line 151 "../src/theme.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 151 "../src/theme.vala"
	_g_free0 ((*dest).grid_color);
#line 151 "../src/theme.vala"
	(*dest).grid_color = _tmp7_;
#line 151 "../src/theme.vala"
	_tmp8_ = (*self).player1;
#line 151 "../src/theme.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 151 "../src/theme.vala"
	_g_free0 ((*dest).player1);
#line 151 "../src/theme.vala"
	(*dest).player1 = _tmp9_;
#line 151 "../src/theme.vala"
	_tmp10_ = (*self).player2;
#line 151 "../src/theme.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 151 "../src/theme.vala"
	_g_free0 ((*dest).player2);
#line 151 "../src/theme.vala"
	(*dest).player2 = _tmp11_;
#line 151 "../src/theme.vala"
	_tmp12_ = (*self).player1_with_colon;
#line 151 "../src/theme.vala"
	_tmp13_ = g_strdup (_tmp12_);
#line 151 "../src/theme.vala"
	_g_free0 ((*dest).player1_with_colon);
#line 151 "../src/theme.vala"
	(*dest).player1_with_colon = _tmp13_;
#line 151 "../src/theme.vala"
	_tmp14_ = (*self).player2_with_colon;
#line 151 "../src/theme.vala"
	_tmp15_ = g_strdup (_tmp14_);
#line 151 "../src/theme.vala"
	_g_free0 ((*dest).player2_with_colon);
#line 151 "../src/theme.vala"
	(*dest).player2_with_colon = _tmp15_;
#line 151 "../src/theme.vala"
	_tmp16_ = (*self).player1_win;
#line 151 "../src/theme.vala"
	_tmp17_ = g_strdup (_tmp16_);
#line 151 "../src/theme.vala"
	_g_free0 ((*dest).player1_win);
#line 151 "../src/theme.vala"
	(*dest).player1_win = _tmp17_;
#line 151 "../src/theme.vala"
	_tmp18_ = (*self).player2_win;
#line 151 "../src/theme.vala"
	_tmp19_ = g_strdup (_tmp18_);
#line 151 "../src/theme.vala"
	_g_free0 ((*dest).player2_win);
#line 151 "../src/theme.vala"
	(*dest).player2_win = _tmp19_;
#line 151 "../src/theme.vala"
	_tmp20_ = (*self).player1_turn;
#line 151 "../src/theme.vala"
	_tmp21_ = g_strdup (_tmp20_);
#line 151 "../src/theme.vala"
	_g_free0 ((*dest).player1_turn);
#line 151 "../src/theme.vala"
	(*dest).player1_turn = _tmp21_;
#line 151 "../src/theme.vala"
	_tmp22_ = (*self).player2_turn;
#line 151 "../src/theme.vala"
	_tmp23_ = g_strdup (_tmp22_);
#line 151 "../src/theme.vala"
	_g_free0 ((*dest).player2_turn);
#line 151 "../src/theme.vala"
	(*dest).player2_turn = _tmp23_;
#line 1047 "theme.c"
}

static void
theme_manager_theme_destroy (ThemeManagerTheme* self)
{
#line 153 "../src/theme.vala"
	_g_free0 ((*self).title);
#line 154 "../src/theme.vala"
	_g_free0 ((*self).fname_tileset);
#line 155 "../src/theme.vala"
	_g_free0 ((*self).fname_bground);
#line 156 "../src/theme.vala"
	_g_free0 ((*self).grid_color);
#line 157 "../src/theme.vala"
	_g_free0 ((*self).player1);
#line 158 "../src/theme.vala"
	_g_free0 ((*self).player2);
#line 159 "../src/theme.vala"
	_g_free0 ((*self).player1_with_colon);
#line 160 "../src/theme.vala"
	_g_free0 ((*self).player2_with_colon);
#line 161 "../src/theme.vala"
	_g_free0 ((*self).player1_win);
#line 162 "../src/theme.vala"
	_g_free0 ((*self).player2_win);
#line 163 "../src/theme.vala"
	_g_free0 ((*self).player1_turn);
#line 164 "../src/theme.vala"
	_g_free0 ((*self).player2_turn);
#line 1077 "theme.c"
}

static ThemeManagerTheme*
theme_manager_theme_dup (const ThemeManagerTheme* self)
{
	ThemeManagerTheme* dup;
#line 151 "../src/theme.vala"
	dup = g_new0 (ThemeManagerTheme, 1);
#line 151 "../src/theme.vala"
	theme_manager_theme_copy (self, dup);
#line 151 "../src/theme.vala"
	return dup;
#line 1090 "theme.c"
}

static void
theme_manager_theme_free (ThemeManagerTheme* self)
{
#line 151 "../src/theme.vala"
	theme_manager_theme_destroy (self);
#line 151 "../src/theme.vala"
	g_free (self);
#line 1100 "theme.c"
}

static GType
theme_manager_theme_get_type_once (void)
{
	GType theme_manager_theme_type_id;
	theme_manager_theme_type_id = g_boxed_type_register_static ("ThemeManagerTheme", (GBoxedCopyFunc) theme_manager_theme_dup, (GBoxedFreeFunc) theme_manager_theme_free);
	return theme_manager_theme_type_id;
}

static GType
theme_manager_theme_get_type (void)
{
	static volatile gsize theme_manager_theme_type_id__once = 0;
	if (g_once_init_enter (&theme_manager_theme_type_id__once)) {
		GType theme_manager_theme_type_id;
		theme_manager_theme_type_id = theme_manager_theme_get_type_once ();
		g_once_init_leave (&theme_manager_theme_type_id__once, theme_manager_theme_type_id);
	}
	return theme_manager_theme_type_id__once;
}

static void
theme_manager_class_init (ThemeManagerClass * klass,
                          gpointer klass_data)
{
#line 21 "../src/theme.vala"
	theme_manager_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/theme.vala"
	g_type_class_adjust_private_offset (klass, &ThemeManager_private_offset);
#line 21 "../src/theme.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_theme_manager_get_property;
#line 21 "../src/theme.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_theme_manager_set_property;
#line 21 "../src/theme.vala"
	G_OBJECT_CLASS (klass)->finalize = theme_manager_finalize;
#line 21 "../src/theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_THEME_ID_PROPERTY, theme_manager_properties[THEME_MANAGER_THEME_ID_PROPERTY] = g_param_spec_int ("theme-id", "theme-id", "theme-id", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_BOARD_SIZE_PROPERTY, theme_manager_properties[THEME_MANAGER_BOARD_SIZE_PROPERTY] = g_param_spec_uchar ("board-size", "board-size", "board-size", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_PB_TILESET_RAW_PROPERTY, theme_manager_properties[THEME_MANAGER_PB_TILESET_RAW_PROPERTY] = g_param_spec_object ("pb-tileset-raw", "pb-tileset-raw", "pb-tileset-raw", gdk_pixbuf_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_PB_BGROUND_RAW_PROPERTY, theme_manager_properties[THEME_MANAGER_PB_BGROUND_RAW_PROPERTY] = g_param_spec_object ("pb-bground-raw", "pb-bground-raw", "pb-bground-raw", gdk_pixbuf_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme.vala"
	theme_manager_signals[THEME_MANAGER_THEME_CHANGED_SIGNAL] = g_signal_new ("theme-changed", TYPE_THEME_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1147 "theme.c"
}

static void
theme_manager_instance_init (ThemeManager * self,
                             gpointer klass)
{
#line 21 "../src/theme.vala"
	self->priv = theme_manager_get_instance_private (self);
#line 24 "../src/theme.vala"
	self->priv->theme_set = FALSE;
#line 86 "../src/theme.vala"
	self->priv->pixmaps_loaded = FALSE;
#line 1160 "theme.c"
}

static void
theme_manager_finalize (GObject * obj)
{
	ThemeManager * self;
#line 21 "../src/theme.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_THEME_MANAGER, ThemeManager);
#line 90 "../src/theme.vala"
	_g_object_unref0 (self->priv->_pb_tileset_raw);
#line 91 "../src/theme.vala"
	_g_object_unref0 (self->priv->_pb_bground_raw);
#line 21 "../src/theme.vala"
	G_OBJECT_CLASS (theme_manager_parent_class)->finalize (obj);
#line 1175 "theme.c"
}

static GType
theme_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ThemeManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) theme_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ThemeManager), 0, (GInstanceInitFunc) theme_manager_instance_init, NULL };
	GType theme_manager_type_id;
	theme_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "ThemeManager", &g_define_type_info, 0);
	ThemeManager_private_offset = g_type_add_instance_private (theme_manager_type_id, sizeof (ThemeManagerPrivate));
	return theme_manager_type_id;
}

GType
theme_manager_get_type (void)
{
	static volatile gsize theme_manager_type_id__once = 0;
	if (g_once_init_enter (&theme_manager_type_id__once)) {
		GType theme_manager_type_id;
		theme_manager_type_id = theme_manager_get_type_once ();
		g_once_init_leave (&theme_manager_type_id__once, theme_manager_type_id);
	}
	return theme_manager_type_id__once;
}

static void
_vala_theme_manager_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	ThemeManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_THEME_MANAGER, ThemeManager);
#line 21 "../src/theme.vala"
	switch (property_id) {
#line 21 "../src/theme.vala"
		case THEME_MANAGER_THEME_ID_PROPERTY:
#line 21 "../src/theme.vala"
		g_value_set_int (value, theme_manager_get_theme_id (self));
#line 21 "../src/theme.vala"
		break;
#line 21 "../src/theme.vala"
		case THEME_MANAGER_BOARD_SIZE_PROPERTY:
#line 21 "../src/theme.vala"
		g_value_set_uchar (value, theme_manager_get_board_size (self));
#line 21 "../src/theme.vala"
		break;
#line 21 "../src/theme.vala"
		case THEME_MANAGER_PB_TILESET_RAW_PROPERTY:
#line 21 "../src/theme.vala"
		g_value_set_object (value, theme_manager_get_pb_tileset_raw (self));
#line 21 "../src/theme.vala"
		break;
#line 21 "../src/theme.vala"
		case THEME_MANAGER_PB_BGROUND_RAW_PROPERTY:
#line 21 "../src/theme.vala"
		g_value_set_object (value, theme_manager_get_pb_bground_raw (self));
#line 21 "../src/theme.vala"
		break;
#line 1234 "theme.c"
		default:
#line 21 "../src/theme.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/theme.vala"
		break;
#line 1240 "theme.c"
	}
}

static void
_vala_theme_manager_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	ThemeManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_THEME_MANAGER, ThemeManager);
#line 21 "../src/theme.vala"
	switch (property_id) {
#line 21 "../src/theme.vala"
		case THEME_MANAGER_THEME_ID_PROPERTY:
#line 21 "../src/theme.vala"
		theme_manager_set_theme_id (self, g_value_get_int (value));
#line 21 "../src/theme.vala"
		break;
#line 21 "../src/theme.vala"
		case THEME_MANAGER_BOARD_SIZE_PROPERTY:
#line 21 "../src/theme.vala"
		theme_manager_set_board_size (self, g_value_get_uchar (value));
#line 21 "../src/theme.vala"
		break;
#line 1266 "theme.c"
		default:
#line 21 "../src/theme.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/theme.vala"
		break;
#line 1272 "theme.c"
	}
}

